const skills = {
    ...skill1,
    '技能石：命运感知(高仿)' : new Element({
        canUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        func : function(){
            showAllMap();
            winMsg('命运指引着你', false, false);
            return true;
        },
        text : '戏命师种族技能，直接点亮所有地图'
    }),
    '技能石：吓唬(高仿)' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(data.battleMonster.xh){
                winMsg('每场战斗只能使用一次',false,false)
                return false;
            }

            data.battleMonster.xh = true;
            if(!data.battleMonster.type && randomNum() <= (100 - (data.battleMonster.level * 0))){
                msg('对方被你吓走了');
                battleEnd();
                setTimeout(function(){timeLapses(battleRunMin);},100)
            }else{
                data.battleMonster.atk += parseInt(data.battleMonster.atk * 0.2)
                addBattleLog('对方没有被你吓住，反而激发了凶性，攻击力提高20%')
            }

            return true;
        },
        text : '狐族种族技能，变成可怕的怪物吓唬敌人，如果吓唬成功，敌人会直接逃跑，结束战斗，但是你无法获得经验和战利品。对普通怪物使用才有可能成功，对精英及以上的怪物使用也允许使用，但是必定会失败。敌人每有1级，成功率降低0%，所以对无限级以上的怪物使用都不一定会失败。如果吓唬失败，敌人会被激发凶性，其攻击力将提高20%。'
    }),
    //理之律者技能
    '技能石：理之权能' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 4,
        myHp : function(){
            data.hp += 10000;
            data.atk += 10000;
            data.maxHp += 10000;
            data.def += 10000;
            winMsg('空手制造', false, false);
            return true;
        },
        text : '(被动)理之律者的权能，可以凭空创造出奇迹……'
    }),
    //裂空座技能
    '技能石：飞翔' : new Element({
        battleUse : true,
        weight : 5,
        noSuck :true,
        endurance : 50,
        voidDust : 20,
        quality : 1,
        gold : 250,
        myHp : function(){
            if(randomNum(1,100) <= 100){
                addBattleLog(`你使出了飞翔。`)
                addStatus(data.battleMonster, getStatus('飞翔的裂空座', {num : 1}));
            }

            return true;
        },
        text : '被动技能，受裂空座的力量影响，现在该技能由普通的飞翔技能进化成了更强大的形态。降低敌人90%命中率。'
    }),
    '技能石：画龙点睛' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 4,
        func : function(){
        data.battleMonster.hp -= data.hp - data.battleMonster.def * 0.1;
        data.hp -= data.hp * 0.5;
        data.def = 0;
        data.atk *= 2;
            return true;
        },
        text : '裂空座的绝招：画龙点睛，飞到臭氧层，随后俯冲而下撞击敌人，对敌人造成大量伤害。注：由于裂空座灵魂受损，一场战斗中每使用一次，自身生命值减半，同时使用一次后该战斗中自身防御值归零，但是攻击值翻倍。该技能无视敌人九成防御值。'
    }),
    //禁忌者技能
    '技能石：禁忌·永恒' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 4,
        func : function(){
        data.hp = data.hp * 2;
        data.maxHp = data.maxHp * 2;
        data.atk = data.atk * 2;
        data.def = data.def * 2;
            return true;
        },
        text : '禁忌的永恒，一场战斗中可无限次数使用。'
    }),
    '技能石：禁忌·时间' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 4,
        myHp : function(){
        data.hp = data.maxHp * 100;
        data.maxHp = data.maxHp * 100;
        data.atk = data.atk * 100;
        data.def = data.def * 100;
        data.battleMonster.def = 0;
        data.battleMonster.atk = 0;
            return true;
        },
        text : '(终极技能·被动)过去，现在，未来……无尽时间线中的我啊…来助此刻的我一臂之力吧！'
    }),
    //仙武传人技能
    '技能石：紫薇心经' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 4,
        func : function(){
        if(data.battleMonster.jjsh){
                winMsg('你已经开始运转紫薇心经……',false,false)
                return false;
            }
            data.battleMonster.jjsh = true;
        data.hp += data.atk * 10 + data.def * 10;
        data.maxHp += data.maxHp * 10 + data.atk * 10 + data.def * 10;
        data.atk = 0;
        data.def = 0;
            return true;
        },
        text : '仙武传人专属主动技能，放弃一切攻击值与防御值，增加自身相当于(攻击值*10+防御值*10+生命值上限*10)的生命生命值上限与(攻击值*10+防御值*10)的生命值，只能使用一次。'
    }),
    '技能石：斗转星移' : new Element({
    battleUse : true,
    weight : 0,
    voidDust : 0,
    quality : 4,
    endurance : 1000,
    gold : 999999999,
    myHp : function(){
        data.battleMonster.hp -= data.maxHp - data.hp;
        return true;
    },
    text : '仙武传人的专属被动技能，对敌人造成自身所受伤害的伤害。'
}),
    //僵小鱼技能
    '技能石：尸祖血脉' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 4,
        func : function(){
            data.hp += data.battleMonster.maxHp * 0.1;
            data.maxHp += data.battleMonster.maxHp * 0.1;
            data.battleMonster.hp -= data.battleMonster.maxHp * 0.1;
            data.battleMonster.maxHp -= data.battleMonster.hp * 0.1;
            data.def += data.battleMonster.def * 0.1;
            data.battleMonster.def -= data.battleMonster.def * 0.1;
            if(data.battleMonster.hp <= data.maxHp){
            battleWin();
        }
            return true;
        },
        text : '僵小鱼拥有尸祖的血脉，可以无视距离限制吸食获取敌人血液与体质，敌人生命值小于等于僵小鱼的生命值上限时敌人死亡。'
    }),
    '技能石：噬明览月I' : new Element({
        battleUse : true,
        voidDust : 0,
        quality : 2,
        gold : 0,
        func : function(){
              if(data.battleMonster.aaaaa){
                winMsg('每场战斗只能使用一次',false,false)
                return false;
            }
          
          if(randomNum(1,100) >= 30){
                data.gold += 100;
                return true;
            }
          
           data.battleMonster.aaaaa = true;
           data.battleMonster.hp -= parseInt(data.battleMonster.maxHp * 0.15);
           data.hp -= data.battleMonster.atk + data.battleMonster.def;
            addBattleLog(`一轮明月挂天穹，几黯明光空？${data.battleMonster.showName || data.battleMonster.name}减少了${data.battleMonster.maxHp * 0.15}生命值，腐旧的岁月侵蚀夺走了你的部分生命值，你减少了${data.battleMonster.atk + data.battleMonster.def}的生命值`)
            return true;
        },
        text : '剥夺怪物15%的生命值，但岁月的腐朽同样夺走你部分的生命值。这份岁月会随时间而变化，有30%概率增加100金币。'
    }),
    '技能石：噬明览月II' : new Element({
        battleUse : true,
        voidDust : 0,
        quality : 2,
        gold : 0,
        func : function(){
              if(data.battleMonster.aaaaa){
                winMsg('每场战斗只能使用一次',false,false)
                return false;
            }
          
          if(randomNum(1,100) >= 50){
                data.gold += 100;
                return true;
            }
          
           data.battleMonster.aaaaa = true;
           data.battleMonster.hp -= parseInt(data.battleMonster.maxHp * 0.4);
           data.hp -= data.battleMonster.atk;
            addBattleLog(`一轮明月挂天穹，几黯明光空？${data.battleMonster.showName || data.battleMonster.name}减少了${data.battleMonster.maxHp * 0.4}生命值，平滑的岁月侵蚀夺走了你的部分生命值，你减少了${data.battleMonster.atk}生命值`)
            return true;
        },
        text : '剥夺怪物40%的生命值，但岁月的平顺同样夺走你部分的生命值。这份岁月会随时间而变化，有50%概率增加100金币。'
    }),
    '技能石：噬明览月III' : new Element({
        battleUse : true,
        voidDust : 0,
        quality : 2,
        gold : 0,
        func : function(){
              if(data.battleMonster.aaaaa){
                winMsg('每场战斗只能使用一次',false,false)
                return false;
            }
          
          if(randomNum(1,100) >= 70){
                data.gold += 100;
                return true;
            }
          
           data.battleMonster.aaaaa = true;
           data.battleMonster.hp -= parseInt(data.battleMonster.maxHp * 0.5);
           data.maxHp += data.battleMonster.atk + data.battleMonster.def;
            addBattleLog(`一轮明月挂天穹，几黯明光空？${data.battleMonster.showName || data.battleMonster.name}减少了${data.battleMonster.maxHp * 0.5}生命值，天成的岁月使你增加了${data.battleMonster.atk + data.battleMonster.def}生命值`)
            return true;
        },
        text : '剥夺怪物50%的生命值，但岁月的不再巧夺天工夺走你部分的生命值，这股岁月转化为部分增长。这份岁月会随时间而变化，有70%概率增加100金币。'
    }),
    '技能石：噬明览月ld' : new Element({
        battleUse : true,
        voidDust : 0,
        quality : 2,
        gold : 0,
        func : function(){
              if(data.battleMonster.aaaaa){
                winMsg('每场战斗只能使用一次',false,false)
                return false;
            }
          
          if(randomNum(1,100) >= 80){
                data.gold += 100;
                return true;
            }
          
           data.battleMonster.aaaaa = true;
           data.battleMonster.hp -= parseInt(data.battleMonster.maxHp * 0.7);
           data.maxHp += data.level * 100;
            addBattleLog(`一轮明月挂天穹，几黯明光空？${data.battleMonster.showName || data.battleMonster.name}减少了${data.battleMonster.maxHp * 0.7}生命值，吾为生反之王，爬蚁？叩下！君王增加了${data.level * 100}生命值`)
            return true;
        },
        text : '剥夺怪物70%的生命值，一叩之上，万灵朝拜，君王的生命增加data.level*100。这份岁月会随时间而变化，有80%概率增加100金币。'
    }),
    '技能石：往墟剑典I' : new Element({
        onlyOne :true,
        isWeapon : true,
        noSuck :true,
        weight : 0,
        endurance : 1000,
        voidDust : 0,
        quality : 2,
        preFunc : function(){
            if(!checkRace('往墟剑典I', true)){
                return false;
            }

            addStatus(data.battleMonster, getStatus('燃烧',{harm : parseInt(this.myAtk() * 0.15)}));
            addStatus(data, getStatus('飞龙在天'))
            addBattleLog(`飞龙在天，此乃大吉也，附加阴阳中阴的腐旧之力形成叠加的状态：燃烧`)

            return true;
        },
        myAtk : function(){
            if(!checkRace('往墟剑典I')){
                return 0;
            }
            return parseInt((data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0)) * 0.5)
        },
        text : '周目唯次强武器，具备极强威能。造成0.5倍伤害，每回合造成此次伤害的15%。增加一些神秘状态。本技能无法触发吸血。'
    }),
    '技能石：往墟剑典II' : new Element({
        onlyOne :true,
        isWeapon : true,
        noSuck :true,
        weight : 0,
        endurance : 1000,
        voidDust : 0,
        quality : 2,
        preFunc : function(){
            if(!checkRace('往墟剑典II', true)){
                return false;
            }

            addStatus(data.battleMonster, getStatus('燃烧',{harm : parseInt(this.myAtk() * 0.35)}));
            addStatus(data, getStatus('飞龙在天'))
            addBattleLog(`飞龙在天，此乃大吉也，附加阴阳中阴的腐旧之力形成叠加的状态：燃烧`)

            return true;
        },
        myAtk : function(){
            if(!checkRace('往墟剑典II')){
                return 0;
            }
            return parseInt((data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0)) * 1.2)
        },
        text : '周目唯次强武器，具备极强威能。造成1.2倍伤害，增加一些神秘状态。本技能无法触发吸血。每回合造成此次伤害的35%。'
    }),
    '技能石：往墟剑典III' : new Element({
        onlyOne :true,
        isWeapon : true,
        noSuck :true,
        weight : 0,
        endurance : 1000,
        voidDust : 0,
        quality : 2,
        preFunc : function(){
            if(!checkRace('往墟剑典III', true)){
                return false;
            }

            addStatus(data.battleMonster, getStatus('燃烧',{harm : parseInt(this.myAtk() * 0.45)}));
            addStatus(data, getStatus('飞龙在天'))
            addBattleLog(`飞龙在天，此乃大吉也，附加阴阳中阴的腐旧之力形成叠加的状态：燃烧`)

            return true;
        },
        myAtk : function(){
            if(!checkRace('往墟剑典III')){
                return 0;
            }
            return parseInt((data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0)) * 2.5)
        },
        text : '周目唯次强武器，具备极强威能。造成2.5倍伤害，增加一些神秘状态。本技能无法触发吸血。每回合造成此次伤害的45%。'
    }),
    '技能石：往墟剑典ld' : new Element({
        onlyOne :true,
        isWeapon : true,
        noSuck :true,
        weight : 0,
        endurance : 5000,
        voidDust : 0,
        quality : 2,
        preFunc : function(){
            if(!checkRace('往墟剑典ld', true)){
                return false;
            }

            addStatus(data.battleMonster, getStatus('燃烧',{harm : parseInt(this.myAtk() * 1.5)}));
            addStatus(data, getStatus('飞龙在天'))
            addBattleLog(`飞龙在天，此乃大吉也，附加阴阳中阴的腐旧之力形成叠加的状态：燃烧`)

            return true;
        },
        myAtk : function(){
            if(!checkRace('往墟剑典ld')){
                return 0;
            }
            return parseInt((data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0)) * 10)
        },
        text : '周目唯次强武器，具备极强威能。造成10倍伤害，增加一些神秘状态。本技能无法触发吸血。每回合造成此次伤害的150%。'
    }),
    '技能石：stayhere' : new Element({
        battleUse : true,
        voidDust : 0,
        quality : 4,
        gold : 0,
        func : function(){
            if(data.battleMonster.stayhere >= 3){
                winMsg('每场战斗只能使用3次',false,false)
                return false;
            }

            if(!data.battleMonster.stayhere){
                data.battleMonster.stayhere = 1;
            }else{

                data.battleMonster.stayhere += 1;
            }

            if(data.hp > data.maxHp * 0.5){
                data.hp = data.maxHp;
                addBattleLog(`打算呆在这里吗？再等等…你恢复了${battleAddHp(data, data.maxHp)}`)
                return true;
            }
            
            data.suck *= 2;
            data.shield *= 2;
            addBattleLog('你使用了stayhere，吸血*2、护盾*2')
            data.hp = data.maxHp;
            return true;
        },
        text : '“stayhere.”你宁愿呆在这里吗？还是被种种束缚了手脚呢。<br>倘若生命小于50%，则吸血*2、护盾*2；无论是否生命小于50%，都会恢复全部血量'
    }),
    '技能石：龙骨附魔' : new Element({
        battleUse : true,
        voidDust : 0,
        quality : 2,
        gold : 0,
        func : function(){
            if(data.battleMonster.ggsh){
                winMsg('每场战斗只能使用一次',false,false)
                return false;
            }

            data.battleMonster.ggsh = true;
            data.suck += 300;
            data.maxSan -= 1;
            data.san -= 1;
            data.hp -= data.level * 100;
            const text = `煞气入侵你的身体，你减少1理智及上限！龙骨发挥效果效果，体内增加了300%吸血。咦…我的理智…减少了${data.level*100}的血量`;
            addBattleLog(text)
            return true;
        },
        text : '这根龙骨是吞噬吸血鬼能力的噬空龙种身上的脊骨，被其打造成了具备附魔能力的物品…但这龙骨是有煞气的，你需要付出一点什么呢？(战斗中查探)战斗中使用会增加300%吸血，并减少1理智及上限(必须>0)，每场战斗只能使用一次'
    }),
    '技能石：无垢之净' : new Element({
        battleUse : true,
        voidDust : 0,
        quality : 2,
        gold : 0,
        func : function(){
            if(data.battleMonster.wgzd){
                winMsg('无垢之净正在慢慢洗礼怪物', false, false)
                return false;
            }
            data.battleMonster.wgzd = true;

            let text = `伽莉尔的第三只眼无垢正在洗礼${data.battleMonster.showName || data.battleMonster.name}，${data.battleMonster.showName || data.battleMonster.name}被附加了枯萎状态，怪物没救了，赐予毁灭的枯萎之花。`;
            addStatus(data.battleMonster, getStatus('枯萎', {keep : true, num : 1, harm : data.level * 3}));
            data.battleMonster.def -= data.level * data.level;
            text += `并且防御力减少${data.level * data.level}。`;
            addBattleLog(text)
            return true;
        },
        text : '无垢洗礼，赐予枯萎状态，每回合减少你的相当于你的等级*3的生命值，该状态不会自动消失。并减少对方相当于你等级*等级的防御力，每场战斗只能使用一次'
    }),
    '技能石：仁慈' : new Element({
        battleUse : true,
        voidDust : 0,
        quality : 4,
        gold : 0,
        func : function(){
        if(data.battleMonster.hp <= 10000){
                return 'win';
          }
          
          if(data.battleMonster.run){
                winMsg('每场战斗只能使用一次',false,false)
                return false;
            }
          
           data.battleMonster.run = true;
           data.battleMonster.hp -= parseInt(data.battleMonster.maxHp * 0.5);
           data.hp -= parseInt(data.maxHp * 0.5);
           data.battleMonster.maxHp -= parseInt(data.battleMonster.maxHp * 0.5);
           data.maxHp -= parseInt(data.maxHp * 0.5);
            addStatus(data.battleMonster, getStatus('愤怒', {keep : true, num : 1, harm : data.maxSan * 3}));
            addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}被你的仁慈感到愤怒，怪物的生命值减少了${data.battleMonster.maxHp*0.5},你的生命值减少了${data.maxHp * 0.5}`)
            return true;
        },
        text : '传说中孤岛有一位凡人曾偷走过创世神的仁慈，并且成功带给开拓者的你使用。<br>创世神因此设下限制，只要使用“仁慈”就会激怒怪物，所以必须慢慢来…<br>怪物的生命减半(每回合有额外伤害，怪物生命小于10000直接死亡)，因强行使用仁慈你也会受到反噬,且反噬极其严重！△你的生命同样减半！注：每回合对敌人造成相当于自身累积值三倍的伤害'
    }),
    '技能石：术' : new Element({
        battleUse : true,
        voidDust : 0,
        quality : 2,
        gold : 0,
        func : function(){
            if(data.battleMonster.startAttrs){
                data.battleMonster.atk = data.battleMonster.startAttrs.atk;
                data.battleMonster.def = data.battleMonster.startAttrs.def;
                addBattleLog(`你使用了术，${data.battleMonster.showName || data.battleMonster.name}的属性被重置了。`)
            }else{
                addBattleLog(`这个怪物没有读取到初始属性，无法使用术`)
                return false;
            }
            return true;
        },
        text : '外是万里禁棘，灰蒙古老往墟六道阵内。<br>伽莉尔、月球之子借用往墟君王的往墟之力反向研究三天三夜，足以无限重置怪物的属性。'
    }),
    '技能石：典' : new Element({
        battleUse : true,
        voidDust : 0,
        quality : 2,
        gold : 0,
        func : function(){
            if(data.battleMonster.jfsh){
                winMsg('每场战斗只能使用一次',false,false)
                return false;
            }

            data.battleMonster.jfsh = true;
            data.atk *= 2;
            data.def -= data.level * 10;
            data.suck += 100;
            const text = `！典的内容具备100%吸血。但这是别人智慧的结晶，你也会受到反噬…防御力降低${data.level * 2}。△攻击力*2`;
            addBattleLog(text)
            return true;
        },
        text : '降墟典于星河沉淀凝化你手之一剑，此剑减少data.level*10的防御力、攻击*2…每场战斗只能使用一次。'
    }),
    '技能石：残破香烟' : new Element({
        canUse :true,
        weight : 0,
        voidDust : 0,
        gold : 0,
        func : function(){
        if(data.hp >= 3000){
                data.hp = 1;
                data.exp = 0;
                data.level -= 13;
                data.maxSan = 95;
                data.san = data.maxSan;
                addItem('彩色云雾')
                const text = `保留1血量…等级扣13…经验清空…理智回到${data.maxSan}`;
                winMsg(text)
                return true;
            }else{
                const text = `无法使用香烟，血量不足`;
                winMsg(text, false, false);
                return false;
            }
        },
        text : '血量大于3000且减少2999hp才有资格使用，经验清空等级降低13级。理智上限和理智都回到95，并获得一个彩色云雾。'
    }),
    '技能石：真空降临' : new Element({
        canUse : true,
        voidDust : 0,
        func : function(){
            if(data.san < 10){
                winMsg('理智不足', false, false);
                return false;
            }

            const monsterList = [];
            //获取怪物配置
            const mapName = data.map[data.location[1]][data.location[0]];//地图名
            const monsters = terrainElements[mapName] ? terrainElements[mapName].monster : {};
            //循环怪物配置
            for(let i = 0 ; i < 10 ; i++){
                for(const name in monsters){
                    const prob = monsters[name].prob;//出现概率
                    if(randomNum(1,100) <= prob){
                        if(monsters[name].level >= data.world.level[0] - (monsters[name].type ? 10 : 0) && monsters[name].level <= data.world.level[1] && (!monsters[name].type || monsters[name].type === '精英') && monsters[name].level <= data.level * 0.5){
                            monsterList.push(`${name}`);
                        }
                    }
                }
            }

            data.hp -= data.level;
            monsterList.forEach(e => {
                data.battleMonster = createBattleMonster(e);
                battleWin(true, 0, false);
            })
            winMsg(`你的真空降临毁灭了${monsterList.length}个生灵`)

            return true;
        },
        text : '可以在副本使用，使用后减少等级*1的血量 真空降临→进行10次探索模拟(防卡死)，将其中模拟出现的等级(为1/2)不高于自己的普通和精英怪物全部击杀，并获得击杀奖励。该技能杀死的怪物自身！此版不会失去1理智上限（理智必须>10，使用后目前所有理智不变化，死亡后恢复正常），理智小于0则死亡（所有难度）。注：可以使用残破香烟。'
    }),
    '技能石：月球白镜' : new Element({canUse : true, battleUse : true, voidDust : 0, gold : 0, func(){
            const addHp = (this.myHp ? this.myHp() : elementCfgs[this.name].myHp());
            const text = `使用了月球上腐锈的白镜，恢复${battleAddHp(data, addHp)}HP`;
            msg(text);
            addBattleLog(text)

            if(data.battleMonster && !data.battleMonster.ccyj){
                data.battleMonster.ccyj = true;
                data.maxHp *= 100;
                data.hp = data.maxHp;
                data.exp -= data.level;
                addBattleLog(`血量*100，经验减少${data.level}`)
            }

            return true;
        },
        myHp : function(){
            return data.maxHp;
        }, text : '恢复全部生命值。如果是本次战斗第一次使用，则生命值*100。减少当前相当data.level的经验'}),
    '技能石：血荒图' : new Element({
        battleUse : true,
        voidDust : 0,
        quality : 4,
        gold : 0,
        func : function(){
            if(data.battleMonster.ajah){
                winMsg('神明之下，再无生灵迫二次召唤',false,false)
                return false;
            }

            data.battleMonster.ajah = true;
            data.gold -= data.battleMonster.def * 100;
            data.battleMonster.def -= data.gold;
            const text = `唤醒了神鹰，神鹰之眼洞察敌方弱点，怪物羸弱的防御降低了${data.gold}，贪财的小鹰仔偷了你${data.battleMonster.def * 100}个金币`;
            addBattleLog(text)
            return true;
        },
        text : '古老的神话鸟类，是伽莉尔的宠物，神鹰以技能的模式展现，神明下，万类生灵皆可诛！怪物防御降低相当你金币的值，你的金币会突然失去怪物防御*100的值'
    }),
    '技能石 : 力量压缩(高仿)' :  new Element({
    canUse : true, 
    voidDust : 1806336, 
    gold : 1806336, 
    weight : 0,
    quality : 4,
    func(){
           data.level = 1;
           data.exp = 0;
                    return true;
                }, text : '压缩自身等级，理论上可以无限叠加，但是死后或洗点后，效果清除，该技能是来自小萝莉版本时期玩家外挂类技能，怕你们打不过。'
    }),
    //达克莱伊技能
    '技能石：暗黑洞' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 4,
        gold : 0,
        myHp : function(){
        if(data.battleMonster.jjsh){
                winMsg('你已经许过愿了……',false,false)
                return false;
            }

            data.battleMonster.jjsh = true;
            if(randomNum(1,100) <= 100){
                addBattleLog(`你使出了暗黑洞，${data.battleMonster.showName || data.battleMonster.name}陷入了沉睡，并开始做起了恐怖的噩梦……`)
                addStatus(data.battleMonster, getStatus('沉睡', {num : 10}));
                addStatus(data.battleMonster, getStatus('噩梦', {keep : true, num : 10, harm : data.battleMonster.hp * 0.1}));
            }

            return true;
        },
        text : '100%概率使对方陷入沉睡状态，持续10回合，每回合对敌人造成敌人当前生命值10%伤害。'
    }),
    //电击魔兽技能
    '技能石：雷电拳' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 5,
        noSuck :true,
        endurance : 50,
        voidDust : 20,
        quality : 1,
        gold : 250,
        preFunc : function(){
            if(randomNum(1,100) <= 90){
                addBattleLog(`你使出了雷电拳，${data.battleMonster.showName || data.battleMonster.name}被附加了麻痹状态。`)
                addStatus(data.battleMonster, getStatus('麻痹', {num : 1}));
            }

            return true;
        },
        myAtk : function(){
            return data.atk * 20 + ((data.battleMonster && data.battleMonster.def > 0 ? data.battleMonster.def : 0))
        },
        text : '造成自身攻击值20倍的伤害，无视防御，并且有90%概率使对方陷入麻痹状态，持续1回合。'
    }),
    //莱希拉姆技能
    '技能石：青焰' : new Element({
        onlyOne :true,
        isWeapon : true,
        noSuck :true,
        weight : 0,
        endurance : 5000,
        voidDust : 0,
        quality : 2,
        preFunc : function(){
            if(!checkRace('青焰', true)){
                return false;
            }

            addStatus(data.battleMonster, getStatus('青焰',{harm : parseInt(data.maxCan * 100)}));
            addStatus(data, getStatus('青焰'))
            addBattleLog(`莱希拉姆将使用青焰焚尽一切`)

            return true;
        },
        myAtk : function(){
            if(!checkRace('青焰')){
                return 0;
            }
            return parseInt((data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0)) * 10)
        },
        text : '莱希拉姆将使用青焰焚尽一切……注：对敌人造成自身攻击值加武器攻击值伤害，燃烧伤害为自身累积值百倍'
    }),
    //基拉祈技能
    '技能石：许愿' : new Element({
        onlyOne: true,
        isWeapon : true,
        weight : 0,
        endurance: 1,
        voidDust : 0,
        quality : 4,
        gold : 0,
        preFunc : function(){
        if(!checkRace('许愿', true)){
                return false;
            }
            data.battleMonster.jjsh = true;
            if(randomNum(1,100) <= 100){
                addBattleLog(`七夜的许愿星基拉祈对着流星许愿……`)
            data.suck += 500;
            data.reduceHart = 0.50;
            data.battleMonster.maxHp -= data.battleMonster.maxHp;
            data.battleMonster.hp -= data.battleMonster.hp * 0.90 + 1000000;
            data.battleMonster.def = 0;
            data.battleMonster.atk = 0;
            data.def = 0;
            data.atk = 0;
            }

            return true;
        },
        myAtk : function(){
            return data.hp;
        },
        text : '(终极技能·主动·一次性消耗)七夜的许愿星基拉祈对着流星许愿，愿世间万物复苏，愿人间烟火永存，愿世无战火悲剧，愿花开，愿梦在，愿团聚，愿梦圆。'
    }),
    '技能石：祈愿' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 4,
        gold : 0,
        func : function(){
            if(data.battleMonster.jjsh){
                winMsg('它实现了自己的愿望～',false,false)
                return false;
            }

            data.battleMonster.jjsh = true;
            data.reduceHart += 0.40;
            data.suck += 1000;
            data.hp *= 10;
            data.maxHp *= 10;
            const text = `基拉祈开始许愿……`;
            addBattleLog(text)
            return true;
        },
        text : '基拉祈实现了许愿筏上所写下的愿望……'
    }),
    '技能石：破灭之愿' : new Element({
    onlyOne: true,
    isWeapon: true,
    weight: 0,
    endurance: 1000,
    voidDust: 0,
    quality: 4,
    gold: 999,
    myAtk: function() {
        return data.atk + data.battleMonster.atk + 10000;
    },
    text : '又一个愿望消逝了……'
}),
    //不死族系列技能
    '技能石：不死特性' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 4,
        gold : 0,
        myHp : function(){
            if(data.hp = data.maxHp){
                const text = `不死特性！`;
            }
            if(data.battleMonster.jjsh){
                winMsg('已经尽力了',false,false)
                return false;
            }

            data.battleMonster.jjsh = true;
            data.reduceHart += 0.9999;
            data.hp = data.maxHp * 100;
            data.maxHp = data.maxHp * 100;
            addStatus(data.battleMonster, getStatus('受到反伤', {harm : data.maxHp * 0.01}));
            const addShield = data.maxHp * 100;
                data.shield += addShield;
                addBattleLog(`使用了不死特性，获得${addShield}护盾`)
                return true;
            return true;
        },
        text : '(不死族终极技能·被动·只生效一次)免伤9999/10000，血量与血量上限变为最大血量100倍，敌人攻击你时会受到同等于你最大血量百分之一伤害，并获得一层最大血量100倍的护盾'
    }),
    //守夜人系列技能
    '技能石：斩神一刀' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 4,
        myHp : function(){
                if(data.battleMonster.jjsh){
                winMsg('赢了…吗？',false,false)
                return false;
            }

            data.battleMonster.jjsh = true;
                data.maxHp += data.battleMonster.hp * 0.99;
                data.hp += data.battleMonster.hp * 0.99;
                data.battleMonster.hp -= data.battleMonster.hp * 0.99 + 10000;
                data.battleMonster.maxHp -= data.battleMonster.hp * 0.99 + 10000;
            return true;
        },
        text : '(守夜人终极技能·被动·每场战斗只生效一次)守夜人背对世人，独自面对那无边的黑暗……向死而生，使出足以斩杀一切的一刀，以无上法则之力，对敌人造成其当前生命值99%的血量，斩出出这代表人类最后希望的一刀……'
    }),
    '技能石：刀意' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 4,
        myHp : function(){
                data.battleMonster.def = 0;
                data.reduceHart = 0.5;
            return true;
        },
        text : '守夜人被动技能，向死而生，刀意毁敌（敌人防御值归0），刀意护体（50%伤害减免），以无上刀意彻底摧毁敌人……'
    }),
    //小萝莉～系列技能
    '技能石：身娇' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 4,
        gold : 0,
        myHp : function(){
            if(data.battleMonster.jjsh){
                winMsg('好累～用一次就够了吧～',false,false)
                return false;
            }

            data.battleMonster.jjsh = true;
            data.reduceHart += 0.99;
            data.hp *= 5;
                data.maxHp *= 5;
            addStatus(data, getStatus('复活', {returnHarm : data.maxHp, num : 1}));
            const text = `这样应该就不会死了吧……`;
            addBattleLog(text)
            return true;
        },
        text : '(被动)因为我身体又娇又软……没什么防御……所以，我只能加buff了～但…不知道为什么，感觉还是好软…啊！说错了！是…是什么来着？(免伤99%，血量与血量上限各乘100，增加复活状态)'
    }),
    '技能石：体软' : new Element({canUse : true, battleUse : true, quality : 4, weight : 0, voidDust : 300, gold : 1500, func(){
            const addHp = (this.myHp ? this.myHp() : elementCfgs[this.name].myHp());
            const text = `白丝萝莉之神使用了萝莉神力，恢复${battleAddHp(data, addHp)}HP`;
            msg(text);
            addBattleLog(text)

            if(data.battleMonster && !data.battleMonster.ccyj){
                data.battleMonster.ccyj = true;
                data.suck += 1000;
                data.atk += data.hp * 10;
                addBattleLog('使用了白丝萝莉之神力，增加吸血，攻击力变成攻击加血量*10')
            }
        },
        myHp : function(){
            removeAllDebuff(data);
            addBattleLog( `小萝莉的身体太软了，没有什么负面状态会忍心在她身上停留。（清除了所有负面状态）`)
            return data.maxHp;
        }, text : '(主动)这样应该就不会死了吧……怕死的小萝莉只能让自己变得强大起来……(增加吸血，攻击力增加血量10倍)'}),
    '技能石：易推倒' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 0,
        endurance : 1000,
        voidDust : 0,
        quality : 4,
        gold : 0,
        myAtk : function(){
            return parseInt((data.maxHp / 1) + parseInt(data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0)) * 10 + ((data.battleMonster && data.battleMonster.def > 0 ? data.battleMonster.def : 0)));
        },
        text : '唔……因为经常被人嘲笑总是被史莱姆推倒……所以我只能研究一些自保的手段……来对抗史莱姆了……'
    }),
    '技能石：神通力' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 0,
        endurance : 1000,
        voidDust : 0,
        quality : 4,
        gold : 0,
        myAtk : function(){
            return parseInt((data.atk * 2) + parseInt(data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0)) * 10 + ((data.battleMonster && data.battleMonster.def > 0 ? data.battleMonster.def : 0)));
        },
        text : '(主动)使用看不见的力量攻击对手……'
    }),
    '技能石：广域战力' : new Element({
    battleUse : true,
    weight: 0,
    voidDust: 0,
    quality: 4,
    gold: 999999999,
    myHp : function(){
        if(data.battleMonster.xh){
        winMsg('你已处于广域战力下……',false,false)
        return false;
    }

    data.battleMonster.xh = true;
        data.atk += data.battleMonster.atk * 100;
        return true;
    },
    text : '(终极技能·被动·每场战斗只生效一次)该技能在来到这个世界后发生了巨大的改变……该技能可以轻易改变一个超大型战场的战争局势……'
}),
    '技能石：变身' : new Element({
    battleUse : true,
    weight: 0,
    voidDust: 0,
    quality: 4,
    gold: 999999999,
    myHp : function(){
        if(data.battleMonster.xh){
        winMsg('你已处于变身状态下……',false,false)
        return false;
    }

    data.battleMonster.xh = true;
        data.atk += data.battleMonster.atk * 0.5;
        data.def += data.battleMonster.def * 0.5;
        return true;
    },
    text : '普通百变怪的唯一一个技能，同时也是被动技能，增加自身怪物一半的攻击值防御值……'
}),
'技能石：究极变身' : new Element({
    battleUse : true,
    weight: 0,
    voidDust: 0,
    quality: 4,
    gold: 999999999,
    myHp : function(){
        data.atk += 100000000;
        data.def += 100000000;
        data.maxHp += 100000000;
        data.hp = data.maxHp;
        return true;
    },
    text : '(终极技能·被动·不限次数)我……很丑吗？为什么…为什么大家都不喜欢我？我已经在努力变好看了……可是…我控制不住这种力量……为什么…所有人都离开了我…我好怕……好冷……越来越困了……要不就这样睡过去，永远不再醒来的好……是了，这只是一场噩梦罢了，醒来后，我依旧是当初那个……喜欢笑的普通百变怪……'
}),
    //由克希技能
    '技能石：瞬间失忆' : new Element({
    battleUse : true,
    weight: 0,
    voidDust: 0,
    quality: 4,
    gold: 999999999,
    myHp : function(){
        if(data.battleMonster.xh){
        winMsg('你已经使出了瞬间失忆，敌人因为与你对视，失去了记忆……',false,false)
        return false;
    }

    data.battleMonster.xh = true;
        data.battleMonster.atk = 0;
        data.battleMonster.def = 0;
        return true;
    },
    text : '知识之神由克希的被动技能，可以让与其对视者瞬间失忆……'
}),
    //伊裴尔塔尔技能
    '技能石：死亡之翼' : new Element({
    battleUse : true,
    weight : 0,
    voidDust : 0,
    quality : 4,
    gold : 99999,
    myHp : function(){
        if (!checkRace('死亡之翼', true)) {
            return false;
        }
        const text = `伊裴尔塔尔开始操控死亡的权柄`;
        addBattleLog(text);
        data.battleMonster.maxHp = data.battleMonster.hp * 2 + data.hp; // 提升敌人生命值上限两倍加自身生命值上限的值
        data.hp = data.maxHp;
        return true;
    },
    text : '提升敌方两倍的生命值上限两倍加自身生命值上限的值，自身生命值等同于自身生命值上限。'
}),
'技能石：永恒' : new Element({
    battleUse : true,
    weight : 0,
    voidDust : 0,
    quality : 4,
    gold : 99999,
    myHp : function(){
        data.maxHp = 1;
        return true;
    },
    text : '(终极技能·被动)恢复全部实力的伊裴尔塔尔以无上死亡气息震慑世人，无数生命死亡……'
}),
    //爆肌蚊技能
    '技能石：血液操控' : new Element({
    battleUse :true,
    weight : 0,
    voidDust : 0,
    quality : 4,
    gold : 999999999,
    func : function(){
            data.battleMonster.maxHp += data.battleMonster.maxHp * 0.2;
        data.battleMonster.hp -= data.battleMonster.maxHp * 0.2;
        data.maxHp += data.maxHp * 0.2;
        data.hp += data.hp * 0.2;
        return true;
        },
    text : '爆肌蚊操控敌我双方的血液，开始造血灭血……'
}),
    //哲尔尼亚斯的技能
    '技能石：生命气息' : new Element({
    battleUse :true,
    weight : 0,
    voidDust : 0,
    quality : 4,
    gold : 999999999,
    func : function(){
    if (!checkRace('生命气息', true)) {
                return false;
            }
            if(data.battleMonster.xh){
        winMsg('你已经在弥散生命气息了',false,false)
        return false;
    }
            data.battleMonster.xh = true;
        data.hp += data.maxHp * 2;
        data.maxHp += data.maxHp * 2;
        return true;
        },
    text : '哲尔尼亚斯在来到这个世界后觉醒的特殊能力，增加自身200%血量上限的血量与血量上限，只能使用一次。'
}),
    '技能石：缩小' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 4,
        gold : 99999,
        myHp : function(){
            if (!checkRace('缩小', true)) {
                return false;
            }
            if(data.battleMonster.xh){
        winMsg('你已处于缩小状态中了',false,false)
        return false;
    }
            const text = `你的整个身体缩小了，你变小了，也变强了`;
            addBattleLog(text)
            data.battleMonster.xh = true;
            data.reduceHart += 0.5;
            return true;
        },
        text : '原是增加闪避的效果的技能，在融合了生命之神哲尔尼亚斯的生命气息后发生了特殊的变化。被动效果:50%减伤。'
    }),
    '技能石：妖精气场' : new Element({
        canUse :true,
        battleUse : true,
        voidDust : 20,
        quality : 4,
        gold : 10000,
        myHp : function(){
        if (!checkRace('妖精气场', true)) {
                return false;
            }
            if(data.battleMonster.xh){
        winMsg('你已处于妖精气场之下了',false,false)
        return false;
    }
    data.battleMonster.xh = true;
            const text = '哲尔尼亚斯（生命之神）发动了妖精气场，生命获得了提升';
            winMsg(text);
            addBattleLog(text)
            data.hp += data.battleMonster.hp;
            data.maxHp += data.battleMonster.maxHp;
            removeAllDebuff(data); // 驱散自身所有负面状态
            removeAllBuff(data.battleMonster); // 驱散敌人全部正面状态
            return true;
        },
        text : '生命之神哲尔尼亚斯天生自带的气场，可以获得敌人的血量与血量上限叠加在自己身上。'
    }),
    //美洛耶塔技能
    '技能石：治愈铃声' : new Element({
        canUse :true,
        battleUse : true,
        voidDust : 20,
        quality : 4,
        gold : 10000,
        func : function(){
        if (!checkRace('治愈铃声', true)) {
                return false;
            }
            if(data.battleMonster.xh){
        winMsg('每场战斗只能使用一次',false,false)
        return false;
    }

    data.battleMonster.xh = true;
            const text = `美洛耶塔晃动手链上的铃铛，铃声响起，祂恢复了全部生命值，并移除了自身的所有异常状态与敌人的所有正面buff`;
            winMsg(text);
            addBattleLog(text)
            data.hp = data.maxHp;
            removeAllDebuff(data); // 驱散自身所有负面状态
            removeAllBuff(data.battleMonster); // 驱散敌人全部正面状态
            return true;
        },
        myHp : function(){
            return data.maxHp;
        },
        text : '美洛耶塔最喜爱的手链在祂来到这个世界时被一起带了过来，祂将自身仅剩的所有力量注入手链中，使手链拥有了神奇的能力。'
    }),
    '技能石：唱歌' : new Element({
    onlyOne: true,
    isWeapon: true,
    endurance: 1000,
    weight: 1,
    voidDust: 10,
    quality: 4,
    gold: 9999,
    preFunc: function(weapon) {
        if (!checkRace('唱歌', true)) {
            return false;
        }
        const text = '美洛耶塔的歌声响起……';
        addStatus(data.battleMonster, getStatus('沉醉'));
        addBattleLog(text);
        return true;
    },
    text: '美洛耶塔是天生的歌神，祂的歌声十分地美好动听，无论是谁，只要听到祂的歌声，都会忍不住沉醉其中……'
}),
'技能石：古老之歌' : new Element({
    onlyOne: true,
    isWeapon: true,
    weight: 0,
    endurance: 1000,
    voidDust: 0,
    quality: 4,
    gold: 999,
    ignoreDef: true, // 将ignoreDef设置为常量true，使得技能始终无视敌人防御
    myAtk: function() {
        return (data.atk + data.battleMonster.atk / 2)  + (data.def+ data.battleMonster.def / 2);
    },
    text : '美洛耶塔的古老之歌，让敌人彻底放弃了挣扎……'
}),
'技能石：旋律之舞' : new Element({
    battleUse : true,
    weight: 0,
    voidDust: 0,
    quality: 4,
    gold: 999999999,
    myHp : function(){
    if(data.battleMonster.xh){
        winMsg('你已经在跳旋律之舞了',false,false)
        return false;
    }
    data.battleMonster.xh = true;
    data.battleMonster.def = 0;
    data.battleMonster.atk -= data.battleMonster.atk * 0.5 + 10000;
    data.battleMonster.hp -= data.battleMonster.hp * 0.5 + 10000;
    data.battleMonster.maxHp -= data.battleMonster.maxHp * 0.5 + 10000;
    return true;
},
    text : '美洛耶塔·舞步最擅长的舞蹈……'
}),
'技能石：小偷' : new Element({
    battleUse : true,
    weight: 0,
    voidDust: 0,
    quality: 4,
    gold: 999999999,
    myHp : function(){
    if(data.battleMonster.xh){
        winMsg('你已偷取成功',false,false)
        return false;
    }
    data.battleMonster.xh = true;
    data.def += data.battleMonster.def * 0.2 + 10000;
    data.atk += data.battleMonster.atk * 0.2 + 10000;
    data.hp += data.battleMonster.hp * 0.2 + 10000;
    data.maxHp += data.battleMonster.maxHp * 0.2 + 10000;
    data.battleMonster.def -= data.battleMonster.def * 0.2 + 10000;
    data.battleMonster.atk -= data.battleMonster.atk * 0.2 + 10000;
    data.battleMonster.hp -= data.battleMonster.hp * 0.2 + 10000;
    data.battleMonster.maxHp -= data.battleMonster.maxHp * 0.2 + 10000;
    return true;
},
    text : '喵老大的被动技能，在来到这个世界后貌似发生了一些奇异的变化……'
}),

    //时拉比技能
        '技能石：预知未来' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 4,
        gold : 99999,
        func : function(){
            if (!checkRace('预知未来', true)) {
                return false;
            }
            if(data.battleMonster.xh){
        winMsg('你已经处于预知未来之中了',false,false)
        return false;
    }

    data.battleMonster.xh = true;
            const text = `时间不朽`;
            addBattleLog(text)
            data.hp += data.def * 10;
            data.reduceHart += 0.50;
            return true;
        },
        myHp : function(){
            return data.maxHp;
        },
        text : '爱好和平的时拉比，在守护方面做的很足。'
    }),
    '技能石：灭亡之歌' : new Element({
    onlyOne :true,
    isWeapon : true,
    weight : 0,
    endurance : 1000,
    voidDust : 0,
    quality : 4,
    gold : 999999999,
    ignoreDef : true, // 将ignoreDef设置为常量true，使得技能始终无视敌人防御
    myAtk : function(){
        return data.battleMonster.hp * 0.2 + data.atk;
    },
    text : '时拉比预知未来，意识到自己即将失去大部分力量来到危险的异世界，虽然不想杀戮，但还是专门从死亡之神伊裴尔塔尔（Y神）、基格尔德（Z神）、美洛耶塔（歌姬）那里借鉴学来了一个伤害性被动技能。该被动融合了三神兽与时拉比的时间之能，可以对敌人造成敌人当前生命值的20%加自身攻击值的伤害。'
}),


    //基格尔德技能
    '技能石：核心惩罚者' : new Element({
    battleUse : true,
    weight : 0,
    voidDust : 0,
    quality : 4,
    gold : 999999999,
    func : function(){
        // 计算敌人生命值的二分之一
        const enemyThirdHP = data.battleMonster.hp * (1/2);
        // 计算自身生命值的十分之1
        const selfThirdHP = data.hp * (1/10);
        // 对敌人造成等同于敌人生命值二分之一的伤害，同时对自身造成等同于自身生命值十分之1的伤害
        data.battleMonster.hp -= enemyThirdHP;
        data.hp -= selfThirdHP;
        if(data.battleMonster.hp <= 1){
            battleWin();
        }
        if(data.hp <= 1){
    die(); // 调用自身失败的函数
}

        // 记录战斗日志
        addBattleLog(`对敌人造成了${enemyThirdHP}点伤害，敌人生命值变为${data.battleMonster.hp}`);
        addBattleLog(`自身受到了${selfThirdHP}点伤害，生命值变为${data.hp}`);
        return enemyThirdHP;
    },
    text : '该技能的效果：对敌人造成等同于敌人生命值二分之一的伤害，同时对自身造成等同于自身生命值十分之一的伤害，同时攻击无视防御'
}),
'技能石：群聚变形' : new Element({
        canUse :true,
        battleUse : true,
        voidDust : 20,
        quality : 4,
        gold : 10000,
        myHp : function(){
        if (!checkRace('群聚变形', true)) {
                return false;
            }
            const text = `恢复了自身全部生命值`;
            winMsg(text);
            addBattleLog(text)
            data.hp = data.maxHp;
            removeAllDebuff(data); // 驱散自身所有负面状态
            removeAllBuff(data.battleMonster); // 驱散敌人全部正面状态
            return true;
        },
        text : '基格尔德专属被动技能，恢复自身全部生命值，清除自身全部负面状态，清除敌人全部负面状态，该技能为被动技能。'
    }),
    //幸福蛋技能
    '技能石：天使之吻' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 4,
        gold : 99999,
        myHp : function(){
            if (!checkRace('天使之吻', true)) {
                return false;
            }
            if(data.battleMonster.xh){
        winMsg('你已经使用了天使之吻',false,false)
        return false;
    }

    data.battleMonster.xh = true;
            const text = `可爱的幸福蛋使用了专属技能“天使之吻”，恢复了自身100%最大生命值的生命，增加50%的伤害减免，提升自身1000%最大生命值，并驱散了自身的全部负面状态与敌人的全部正面状态。`;
            addBattleLog(text)
            data.reduceHart = 0.5;
            data.maxHp = data.maxHp * 10;
            data.hp = data.maxHp;
            data.battleMonster.maxHp -= data.battleMonster.maxHp * 0.9;
            data.battleMonster.hp = data.battleMonster.maxHp;
            data.battleMonster.atk -= data.battleMonster.atk * 0.5;
            removeAllDebuff(data); // 驱散自身所有负面状态
            removeAllBuff(data.battleMonster); // 驱散敌人所有正面状态
            return true;
        },
        text : '幸福蛋一族的专属被动技能，恢复自身100%最大生命值的生命，增加50%伤害减免，提升自身1000%最大生命值的生命值上限与生命值，并驱散自身的全部负面状态与敌人的全部正面状态，减少敌人90%生命值上限的生命值上限与生命值，减少敌人一半的防御值。。'
    }),
    '技能石：地球上投' : new Element({
    battleUse : true,
    weight : 0,
    voidDust : 0,
    quality : 4,
    gold : 999,
    func : function(){
        data.hp -= data.level * data.def;
    },
    text : '幸福蛋一族经过无数年的发展推演，该技能的效果已经变成了：对敌人造成等同于自身等级乘防御的伤害。自身攻击无视敌人防御'
}),
    //阿尔宙斯技能
    '技能石：一般系石板' : new Element({
    battleUse : true,
    weight : 0,
    voidDust : 0,
    quality : 4,
    gold : 999999999,
    myHp: function() {
    if(!checkRace('一般系石板', true)){
        return false;
    }
    if(data.battleMonster.xh){
        winMsg('每场战斗只能使用一次',false,false)
        return false;
    }

    data.battleMonster.xh = true;
    const text = `阿尔宙斯使用了一般系石板，为自己增加100倍防御`;
    addBattleLog(text);

    data.def = data.def * 100;

    return true;
},
    text : '阿尔宙斯专属被动技能，获得100倍防御值，每场战斗只生效一次'
    }),
    '技能石：十八属性石板' : new Element({
    battleUse : true,
    weight : 0,
    voidDust : 0,
    quality : 4,
    gold : 999999999,
    myHp: function() {
    if(!checkRace('十八属性石板', true)){
        return false;
    }
    if(data.battleMonster.xh){
        winMsg('每场战斗只能使用一次',false,false)
        return false;
    }

    data.battleMonster.xh = true;
    const text = `阿尔宙斯使用了十八块不同属性的石板，防御、攻击、生命值上限、生命值变为百倍，增加80%伤害减免`;
    addBattleLog(text);

    data.def = data.def * 100;
    data.atk = data.atk * 100;
    data.maxHp = data.maxHp * 100;
    data.hp = data.hp * 100;
    data.reduceHart += 0.8;
    return true;
},
    text : '(终极技能·被动·每场战斗只生效一次)阿尔宙斯专属被动技能，防御值、攻击值、生命值上限、生命值变为原来的百倍，增加80%伤害减免，每场战斗只生效一次'
    }),
    //蒂安希技能
    '技能石：永恒钻石' : new Element({
    battleUse : true,
    weight : 0,
    voidDust : 0,
    quality : 4,
    gold : 999999999,
    func : function(){
    if(!checkRace('永恒钻石', true)){
        return false;
    }
    if(data.battleMonster.xh){
        winMsg('每场战斗只能使用一次',false,false)
        return false;
    }

    data.battleMonster.xh = true;
    const text = `你使用了永恒钻石，为自己增加50%伤害减免，同时提升自身防御值两倍`;
    addBattleLog(text);

    data.reduceHart += 0.5;
    data.def = data.def * 2;

    return true;
},

    myHp : function(){
        return parseInt(data.maxHp * 1);
    },
    text : '蒂安希专属技能，使用后自身获得50%减伤，提升自身两倍防御，不限制回合数，只能使用一次'
    }),
    '技能石：钻石守护' : new Element({
    battleUse : true,
    weight: 0,
    voidDust: 0,
    quality: 4,
    gold: 999999999,
    myHp : function(){
        if(data.battleMonster.xh){
        winMsg('你已经使出了钻石守护，无数钻石环绕在你周身……',false,false)
        return false;
    }

    data.battleMonster.xh = true;
        data.def += data.def * 0.5;
        return true;
    },
    text : '超级·蒂安希的被动技能钻石守护，无数钻石不断浮现……她的防御值不断提升……'
}),
    '技能石：月光' : new Element({
        canUse :true,
        battleUse : true,
        voidDust : 20,
        quality : 4,
        gold : 10000,
        func : function(){
        if (!checkRace('月光', true)) {
                return false;
            }
            if(data.battleMonster.xh){
        winMsg('每场战斗只能使用一次',false,false)
        return false;
    }

    data.battleMonster.xh = true;
            const text = `恢复了自身全部生命值`;
            winMsg(text);
            addBattleLog(text)
            data.hp = data.maxHp;
            removeAllDebuff(data); // 驱散自身所有负面状态
            removeAllBuff(data.battleMonster); // 驱散敌人全部正面状态
            return true;
        },
        myHp : function(){
            return data.maxHp;
        },
        text : '是许多精灵宝可梦都有的技能，无消耗，恢复全部生命值。受钻石公主蒂安希的力量影响，发生了额外变化：驱散自身所有负面状态，驱散敌人全部正面状态。'
    }),
    '技能石：钻石风暴' : new Element({
    onlyOne :true,
    isWeapon : true,
    weight : 0,
    endurance : 1000,
    voidDust : 0,
    quality : 4,
    gold : 0,
    ignoreDef : true, // 将ignoreDef设置为常量true，使得技能始终无视敌人防御
    myAtk : function(){
        return data.def;
    },
    text : '蒂安希专属技能，对敌人造成等同于自身防御的伤害。自身攻击无视敌人防御'
}),

    //食人魔技能
    '技能石：掠食' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 5,
        endurance : 1000,
        voidDust : 0,
        quality : 1,
        gold : 0,
        myAtk : function(){
            if(!checkRace('掠食')){
                return 0;
            }
            const rate = (data.race.name === '食人魔-暴食' || data.race.name === '食人魔-暴君') && data.battleMonster && data.battleMonster.items.filter(e => elementCfgs[e.name].isMeat).length > 0 ? 2 : 1;
            return rate * (parseInt((data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0)) * 1) + parseInt((data.maxHunger - data.hunger) / 5))
        },
        text : '对敌人额外造成(饥饿值上限-当前饥饿值)/5的伤害'
    }),
    '技能石：狂暴' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('狂暴', true)){
                return false;
            }
            if(data.battleMonster.kb){
                winMsg('你已经处于狂暴中了', false, false);
                return false;
            }

            data.battleMonster.kb = true;
            data.atk += parseInt(data.maxHunger / 5);
            data.def -= parseInt(data.maxHunger / 10);
            addBattleLog(`你使用了狂暴，攻击力增加${parseInt(data.maxHunger / 5)}，防御力减少${parseInt(data.maxHunger / 10)}`)
            return true;
        },
        text : '攻击力提高饥饿上限/5，防御力降低饥饿上限/10，每场战斗只能使用一次'
    }),
    '技能石：自食' : new Element({
        battleUse :true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('自食')){
                return false;
            }
            if(!inBattle()){
                winMsg('只能在战斗中使用，请丢弃该技能石重新制造', false, false)
                return false;
            }
            if(data.battleMonster.zs){
                winMsg('你已经吃过自己了', false, false)
                return false;
            }

            data.battleMonster.zs = true;
            const num = parseInt(data.maxHp * 0.2);
            if(data.hp < num){
                winMsg('生命值不足', false, false);
                return false;
            }

            data.hp -= num;
            const number = parseInt(num / 3);
            data.maxHunger += number * 2;
            addObjHunger(data, number);

            addBattleLog('你吃了自己的肉！');
            return true;
        },
        text : '食人魔实在太饿了，于是选择吃自己的肉。消耗20%生命值，每消耗3生命值，恢复1点饥饿值，增加2点饥饿值上限,每场战斗只能使用一次'
    }),
    '技能石：无尽暴食' : new Element({
        canUse :true,
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('无尽暴食')){
                return false;
            }

            if(data.hunger <= 0){
                winMsg('饥饿值不足', false, false);
                return false;
            }

            if(inBattle()){
                data.maxHunger += data.hunger;
            }
            battleAddHp(data, data.hunger * 2);
            data.hunger = 0;

            return true;
        },
        myHp(){
            if(!checkRace('无尽暴食')){
                return 0;
            }
            return data.hunger * 2;
        },
        text : '食人魔-暴食种族技能，为什么越吃越饿了呢。消耗所有饥饿值，每消耗1饥饿值，恢复2点生命值。如果在战斗中使用，则饥饿上限增加消耗的饥饿数'
    }),
    '技能石：铁血' : new Element({
        battleUse :true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('铁血')){
                return false;
            }
            if(data.battleMonster.tx){
                winMsg('你已经是铁血状态了', false, false)
                return false;
            }

            data.battleMonster.tx = true;
            if(!data.suck){
                data.suck = 0;
            }
            data.suck += (data.weapon && data.weapon.suck ? data.weapon.suck : 0) + (data.armor && data.armor.suck ? data.armor.suck : 0) + (data.suck || 0);

            addBattleLog('你进入了铁血状态');
            return true;
        },
        text : '食人魔-暴君种族技能，进入了铁血状态，吸血翻倍，每场战斗只能使用一次'
    }),
    '技能石：爆轰术' : new Element({
        onlyOne :true,
        isWeapon : true,
        endurance : 1000,
        weight : 5,
        noSuck : true,
        voidDust : 0,
        quality : 1,
        gold : 0,
        getAtkNum : function(){
            return getStatuNum(data, '狂热') + 1;
        },
        preFunc : function(weapon){
            if(!checkRace('爆轰术', true)){
                return false;
            }

            const need = parseInt(data.level / 5);
            if(data.hunger < need){
                winMsg('你的饥饿值不足', false, false)
                return;
            }
            data.hunger -= need;

            //获取伤害
            let harm = this.myAtk();

            if(data.race.name === '食人魔-血法师'){
                data.battleMonster.maxHp -= parseInt(harm * 0.2);
                addObjHp(data.battleMonster, 0)
            }
            return true;
        },
        atkAfter(){
            if(getStatuNum(data, '狂热') < 3){
                addStatus(data, getStatus('狂热'))
            }
        },
        myAtk : function(){
            if(!checkRace('爆轰术')){
                return 0;
            }
            return parseInt((data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0)) + (data.level * 10))
        },
        text : '食人魔-双头法师种族技能，消耗相当于你等级/5的饥饿，额外造成消耗的等级*10的额外的伤害，并给自己附加一层狂热状态（最多3层）。每有一层狂热状态，该技能额外攻击一次。本技能无法触发吸血。'
    }),

    //操脑蛛技能
    '技能石：解除操纵' : new Element({
        canUse :true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('解除操纵')){
                return false;
            }
            if(!data.control){
                winMsg('你没有控制怪物', false, false)
                return false;
            }
            winMsg(`你解除了${data.control.showName || data.control.name}的控制`);
            data.control = null;
            const hp = data.hp;
            initAttr();
            data.suck = 0;
            if(data.hp > hp){
                data.hp = hp;
            }
            return true;
        },
        text : '操脑蛛种族技能，解除当前控制的怪物，并自动进行一次洗点。如果解除操纵前的血量低于洗点后的血量，则血量保持为解除操纵前的血量'
    }),
    '技能石：精神狂暴' : new Element({
        battleUse :true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('精神狂暴')){
                return false;
            }
            if(data.battleMonster.jskb){
                winMsg(`你操控的${data.control.showName || data.control.name}已经处于精神狂暴当中`, false, false);
                return false;
            }
            data.battleMonster.jskb = true;

            data.atk += data.control.atk * 3;
            const old = data.control.hp;
            data.control.maxHp = data.control.hp = parseInt(data.control.hp * 0.7)
            const num = old - data.control.hp;
            data.maxHp -= num;
            data.selfAttrs.maxHp -= num;
            if(data.hp > data.maxHp){
                data.hp = data.maxHp;
            }

            addBattleLog(`你强制让你操控的${data.control.showName || data.control.name}陷入了狂暴中`);
            return true;
        },
        text : '操脑蛛种族技能，永久降低被控制怪物30%的生命上限，并将减少的具体数值立刻体现到人物当前的生命值上限，提高控制怪物本身攻击力*3的攻击力。该技能每场战斗只能使用一次'
    }),
    '技能石：怪物强化' : new Element({
        canUse :true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('怪物强化')){
                return false;
            }
            if(!data.control.upNum){
                data.control.upNum = 0;
            }
            const need = 5 * Math.pow(2, data.control.upNum)
            const items = monsterCfgs[data.control.name].items.filter(e => elementCfgs[e.name].fromMonster).map(e => e.name);

            if(items.length === 0){
                winMsg('该怪物没有可强化的材料，无法强化', false, false)
                return;
            }

            if(items.filter(e => getNumByBag(e, data.location.join() === data.world.home.location.join()) >= need).length === items.length){
                items.forEach(e => {
                    //如果是在家，允许使用仓库中的物品
                    if(data.location.join() === data.world.home.location.join()){
                        //获取背包中的数量
                        const bagNum = getNumByBag(e);
                        //优先使用背包中的物品
                        if(bagNum >= need){
                            reduceItem(e, need);
                        }else{
                            if(bagNum > 0){
                                reduceItem(e, bagNum);
                            }
                            reduceItemByStore(e, need - bagNum);
                        }
                    }else{
                        reduceItem(e, need);
                    }
                })
                data.control.upNum++;

                data.control.hp = Math.ceil(data.control.hp * 1.1)
                data.control.atk = Math.ceil(data.control.atk * 1.1)
                data.control.def = Math.ceil(data.control.def * 1.1)

                const hp = data.hp;
                initAttr();
                if(data.hp > hp){
                    data.hp = hp;
                }
                winMsg(`强化成功，消耗[${items.join('，')}]*${need}`)
                return true;
            }else{
                winMsg(`材料不足，此次强化需要[${items.map(e => `${e}*${need}/${getNumByBag(e, data.location.join() === data.world.home.location.join())}`).join('，')}]`)
                return false;
            }
        },
        text : '强化你操纵的怪物的属性，可以无限次数强化，每次强化都会在当前属性上提高10%的血量、攻击和防御(全部向上取整)，并自动进行一次洗点，但是当前血量保持强化前的状态。强化需要消耗操纵的怪物掉落的材料（放在仓库里也可以，不用带在身上），初次强化需要消耗掉落的材料各5个，之后每强化过一次，材料翻倍。即第二次10个，第三次20个，第四次40个。取消操纵时强化获得的属性一并丢失'
    }),

    //污染者技能
    '技能石：自我扭曲' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('自我扭曲', true)){
                return false;
            }
            const num = ndx(5, 4) * (getStatuNum(data, '扭曲形态') + 1)

            if(data.san < num){
                addBattleLog('你试图让自己更加扭曲，但是你的理智不足以控制你的身体');
                return true;
            }

            reduceObjSan(data, num);
            addStatus(data, getStatus('扭曲形态'))

            let attrNum = getStatuNum(data, '扭曲形态') * getCthulhuScholarship();
            const attrs = ['atk','atk','atk','atk','def','def','def','hp','hp','suck'];
            //以下为一次增加获得的点数
            const addNum = {
                atk : 1,
                def : 1,
                hp : parseInt(data.maxHp * 0.01),
                suck : 1,
            }
            if(addNum.hp < 1){addNum.hp = 1}

            for(let i = 0 ; i < attrNum ; i++){
                const attr = attrs.getRandom();
                if(attr === 'suck' && !data.suck){
                    data.suck = 0;
                }
                data[attr] += addNum[attr];
                if(attr === 'hp'){
                    data.maxHp += addNum[attr];
                }
            }

            addBattleLog(`你消耗了${num}理智，并且变得更加扭曲了`)
            return true;
        },
        text : '污染者种族技能，消耗“5d4*(扭曲形态层数+1)”的理智值(当理智不足时会使用失败，并浪费这一回合的行动机会。如果理智正好和需要消耗的理智相同，消耗后会保留1点，而不是变为0)，给自己附加一层扭曲形态，并获得当前扭曲形态层数*克苏鲁学识的随机属性点，这些属性点将自动随机分配，可能分配到以下属性中：攻击（40%概率，1属性点=1攻击）/防御（30%概率，1属性点=1防御）/血量（20%概率，1属性点=1%血量，最少1）/吸血（10%概率，1属性点=1%吸血）'
    }),
    '技能石：无智狂暴' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('无智狂暴', true)){
                return false;
            }

            if(data.san > 10){
                reduceObjSan(data, 10);
                data.atkSpd += 1;
            }else{
                winMsg('理智不足', false, false)
                return false;
            }

            addBattleLog(`你失去了10理智，获得1点攻速加成`)
            return true;
        },
        text : '污染者种族技能，消耗10点理智，获得1点攻速加成'
    }),

    //星灵系技能
    '技能石：时间穿梭' : new Element({
        canUse :true,
        voidDust : 0,
        quality : 1,
        weight : 0,
        gold : 0,
        func : function(){
            if(!checkRace('时间穿梭', true)){
                return false;
            }
            $('.item-use-win-modal').hide();
            $('.item-use-win').hide();
            $('.win').hide();
            $('.time-shuttle').show();
            return true;
        }, text : '星灵种族技能，可以穿梭到未来，具体穿梭到多久后的未来可以自行选择'
    }),

    //精灵系列技能
    '技能石：自然附着' : new Element({
        canUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        func : function(){
            if(!checkRace('自然附着', true)){
                return false;
            }
            renderNaturalAttachment();
            $('.natural-attachment').show();
            return true;
        },
        text : '精灵种族技能，可将非弓类武器的属性附着在弓胚上，附着后，弓胚将获得附着武器的攻击、防御、减伤、吸血、血量、等级、孔数、镶嵌物、品质、名字。'
    }),
    '技能石：木箭' : new Element({
        onlyOne :true,
        isWeapon : true,
        isArrow : true,
        atk : 1,
        endurance : 30,
        voidDust : 0,
        gold : 0,
        preFunc : function(weapon) {
            if (!checkRace('木箭', true)) {
                return false;
            }
            if (!data.weapon || !data.weapon.isBow) {
                winMsg(`必须装备弓类武器`, false, false);
                return false;
            }
            if (data.weapon.level < weapon.level) {
                winMsg(`你的弓用不了这个箭矢`, false, false);
                return false;
            }
            return true;
        },
        myAtk : function(item){
            return getBaseAtk(item.atk);
        },
        text : '精灵制造的箭矢，必须装备等级不低于该箭矢的弓类武器才能使用，可以用背包页面下面里的合并技能石按钮合并多个箭矢。基础伤害为武器攻击力+人物攻击力+箭矢攻击力'
    }),
    '技能石：魔法箭' : new Element({
        onlyOne :true,
        isWeapon : true,
        isArrow : true,
        atk : 5,
        endurance : 30,
        level : 5,
        weight : 2,
        voidDust : 0,
        gold : 0,
        preFunc : function(weapon) {
            if (!checkRace('魔法箭', true)) {
                return false;
            }
            if (!data.weapon || !data.weapon.isBow) {
                winMsg(`必须装备弓类武器`, false, false);
                return false;
            }
            if (data.weapon.level < weapon.level) {
                winMsg(`你的弓用不了这个箭矢`, false, false);
                return false;
            }
            return true;
        },
        myAtk : function(item){
            return getBaseAtk(item.atk);
        },
        text : '精灵制造的箭矢，必须装备等级不低于该箭矢的弓类武器才能使用，可以用背包页面下面里的合并技能石按钮合并多个箭矢。基础伤害为武器攻击力+人物攻击力+箭矢攻击力'
    }),
    '技能石：火焰箭' : new Element({
        onlyOne :true,
        isWeapon : true,
        isArrow : true,
        atk : 5,
        quality : 1,
        level : 10,
        endurance : 30,
        weight : 2,
        voidDust : 0,
        gold : 0,
        preFunc : function(weapon) {
            if (!checkRace('火焰箭', true)) {
                return false;
            }
            if (!data.weapon || !data.weapon.isBow) {
                winMsg(`必须装备弓类武器`, false, false);
                return false;
            }
            if (data.weapon.level < weapon.level) {
                winMsg(`你的弓用不了这个箭矢`, false, false);
                return false;
            }
            return true;
        },
        atkAfter(){
            addStatus(data.battleMonster, getStatus('燃烧', {harm : 50}));
        },
        myAtk : function(item){
            return getBaseAtk(item.atk);
        },
        text : '命中敌方后，给敌方附加燃烧状态，每回合造成50伤害，持续3回合。精灵制造的箭矢，必须装备等级不低于该箭矢的弓类武器才能使用，可以用背包页面下面里的合并技能石按钮合并多个箭矢。基础伤害为武器攻击力+人物攻击力+箭矢攻击力'
    }),
    '技能石：腐蚀箭' : new Element({
        onlyOne :true,
        isWeapon : true,
        isArrow : true,
        atk : 10,
        quality : 2,
        level : 40,
        endurance : 30,
        weight : 1,
        voidDust : 0,
        gold : 0,
        preFunc : function(weapon) {
            if (!checkRace('腐蚀箭', true)) {
                return false;
            }
            if (!data.weapon || !data.weapon.isBow) {
                winMsg(`必须装备弓类武器`, false, false);
                return false;
            }
            if (data.weapon.level < weapon.level) {
                winMsg(`你的弓用不了这个箭矢`, false, false);
                return false;
            }
            return true;
        },
        atkAfter(){
            data.battleMonster.def -= 10;
        },
        myAtk : function(item){
            return getBaseAtk(item.atk);
        },
        text : '命中敌方后，减少敌方10点防御。精灵制造的箭矢，必须装备等级不低于该箭矢的弓类武器才能使用，可以用背包页面下面里的合并技能石按钮合并多个箭矢。基础伤害为武器攻击力+人物攻击力+箭矢攻击力'
    }),
    '技能石：穿甲箭' : new Element({
        onlyOne :true,
        isWeapon : true,
        isArrow : true,
        atk : 1,
        quality : 2,
        level : 50,
        endurance : 30,
        weight : 3,
        voidDust : 0,
        gold : 0,
        preFunc : function(weapon) {
            if (!checkRace('穿甲箭', true)) {
                return false;
            }
            if (!data.weapon || !data.weapon.isBow) {
                winMsg(`必须装备弓类武器`, false, false);
                return false;
            }
            if (data.weapon.level < weapon.level) {
                winMsg(`你的弓用不了这个箭矢`, false, false);
                return false;
            }
            return true;
        },
        myAtk : function(item){
            return getBaseAtk(item.atk, true, true, true);
        },
        text : '无视防御。精灵制造的箭矢，必须装备等级不低于该箭矢的弓类武器才能使用，可以用背包页面下面里的合并技能石按钮合并多个箭矢。基础伤害为武器攻击力+人物攻击力+箭矢攻击力'
    }),
    '技能石：爆裂箭' : new Element({
        onlyOne :true,
        isWeapon : true,
        isArrow : true,
        atk : 5,
        quality : 2,
        level : 50,
        endurance : 30,
        weight : 2,
        voidDust : 0,
        gold : 0,
        atkNum : 5,
        preFunc : function(weapon) {
            if (!checkRace('爆裂箭', true)) {
                return false;
            }
            if (!data.weapon || !data.weapon.isBow) {
                winMsg(`必须装备弓类武器`, false, false);
                return false;
            }
            if (data.weapon.level < weapon.level) {
                winMsg(`你的弓用不了这个箭矢`, false, false);
                return false;
            }
            return true;
        },
        myAtk : function(item){
            return getBaseAtk(item.atk, true, true, false, 0.35);
        },
        text : '造成5次35%的伤害。精灵制造的箭矢，必须装备等级不低于该箭矢的弓类武器才能使用，可以用背包页面下面里的合并技能石按钮合并多个箭矢。基础伤害为武器攻击力+人物攻击力+箭矢攻击力'
    }),
    '技能石：变身巨熊' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('变身巨熊', true)){
                return false;
            }

            if(hasStatus(data, '动物形态')){
                winMsg(`你已经是动物形态了`, false, false);
                return false;
            }

            addStatus(data, getStatus('动物形态'))
            addStatus(data, getStatus('巨熊形态'))

            data.reduceHart += 0.1;
            let addDef = parseInt(data.def * 0.3)
            if(addDef < 200){
                addDef = 200;
            }
            data.reduceHart += 0.1;
            data.def += addDef;
            data.maxHp *= 2;

            addBattleLog(`你变身为了巨熊形态`)
            return true;
        },
        text : '精灵-德鲁伊种族技能，变身为巨熊形态，增加10%减伤，防御力增加30%（至少200），生命上限增加100%。每场战斗只能变身一次'
    }),
    '技能石：变身猎豹' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('变身猎豹', true)){
                return false;
            }

            if(hasStatus(data, '动物形态')){
                winMsg(`你已经是动物形态了`, false, false);
                return false;
            }

            addStatus(data, getStatus('动物形态'))
            addStatus(data, getStatus('猎豹形态'))

            data.atk *= 2;
            data.def = parseInt(data.def / 2)
            data.maxHp = parseInt(data.maxHp / 2)
            addObjHp(data, 0);

            addBattleLog(`你变身为了猎豹形态`)
            return true;
        },
        text : '精灵-德鲁伊种族技能，变身为猎豹形态，增加攻击力翻倍，防御力和生命上限减半。每场战斗只能变身一次'
    }),
    '技能石：撼地击' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 5,
        endurance : 1000,
        voidDust : 0,
        quality : 1,
        gold : 0,
        preFunc : function(weapon) {
            if (!checkRace('撼地击', true)) {
                return false;
            }
            if (!getStatuNum(data, '巨熊形态')) {
                winMsg(`只能在变身为巨熊形态时使用`, false, false);
                return false;
            }
            return true;
        },
        myAtk : function(item){
            return getBaseAtk(item.atk, true, true, false, 0.8);
        },
        atkAfter(){
            if(randomNum(1,100) <= 30){
                addStatus(data.battleMonster, getStatus('眩晕'))
            }
        },
        text : '精灵-德鲁伊种族技能，只能在变身为巨熊形态时使用。造成80%的伤害，并有30%几率眩晕敌方一回合'
    }),
    '技能石：双爪撕裂' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 5,
        endurance : 1000,
        voidDust : 0,
        quality : 1,
        gold : 0,
        atkNum : 2,
        preFunc : function(weapon) {
            if (!checkRace('双爪撕裂', true)) {
                return false;
            }
            if (!getStatuNum(data, '猎豹形态')) {
                winMsg(`只能在变身为猎豹形态时使用`, false, false);
                return false;
            }
            return true;
        },
        myAtk : function(item){
            return getBaseAtk(item.atk, true, true, false, 0.7);
        },
        atkAfter(){
            if(randomNum(1,100) <= 30){
                addStatus(data.battleMonster, getStatus('流血', {harm : data.level * 4}))
            }
        },
        text : '精灵-德鲁伊种族技能，只能在变身为猎豹形态时使用。造成两次70%的伤害，并有30%几率使敌方陷入流血状态，每回合造成玩家等级*4的伤害，持续3回合'
    }),
    '技能石：大地之熊' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('大地之熊', true)){
                return false;
            }

            if(hasStatus(data, '动物形态')){
                winMsg(`你已经是动物形态了`, false, false);
                return false;
            }

            addStatus(data, getStatus('动物形态'))
            addStatus(data, getStatus('巨熊形态'))

            data.reduceHart += 0.2;
            let addDef = data.def
            if(addDef < 500){
                addDef = 500;
            }
            data.reduceHart += 0.1;
            data.def += addDef;
            data.maxHp *= 3;

            addBattleLog(`你变身为了巨熊形态`)
            return true;
        },
        text : '精灵-德鲁伊种族技能，变身为大地之熊形态（本质上依旧是巨熊形态），增加20%减伤，防御力增加100%（至少500），生命上限增加200%。每场战斗只能变身一次'
    }),
    '技能石：幻影猎豹' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('幻影猎豹', true)){
                return false;
            }

            if(hasStatus(data, '动物形态')){
                winMsg(`你已经是动物形态了`, false, false);
                return false;
            }

            addStatus(data, getStatus('动物形态'))
            addStatus(data, getStatus('猎豹形态'))

            data.atk = parseInt(data.atk * 2.5);
            addObjHp(data, 0);

            addBattleLog(`你变身为了猎豹形态`)
            return true;
        },
        text : '精灵-德鲁伊种族技能，变身为幻影猎豹形态（本质上依旧是猎豹形态），增加攻击力增加150%。每场战斗只能变身一次'
    }),

    //半人马系列技能
    '技能石：冲锋' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 5,
        endurance : 1000,
        voidDust : 0,
        quality : 1,
        gold : 0,
        getAtkNum : function(){
            if(data.race.name === '半人马-轻骑兵'){
                if(data.spd < 100){
                    if(randomNum() <= 20){
                        return 2;
                    }
                }else if(data.spd < 199){
                    if(randomNum() <= 40){
                        return 2;
                    }
                }else{
                    if(randomNum() <= 60){
                        return 2;
                    }
                }
            }
            return 1;
        },
        preFunc : function(weapon) {
            if (!checkRace('冲锋', true)) {
                return false;
            }
            return true;
        },
        myAtk : function(item){
            let dd = false;
            let rate = 1;
            let otherAtk = 0;

            if(data.spd < 100){
                dd = randomNum() <= 10;
                rate += data.spd * 0.02;
                if(data.race.name === '半人马-重骑兵'){
                    otherAtk = parseInt(data.def / 2);
                }
            }else if(data.spd < 199){
                dd = randomNum() <= 30;
                rate += randomNum(data.spd * 2, data.spd * 3) / 100;
                if(data.race.name === '半人马-重骑兵'){
                    otherAtk = data.def;
                }
            }else{
                dd = true;
                rate += randomNum(data.spd * 2, data.spd * 4) / 100;
                if(data.race.name === '半人马-重骑兵'){
                    otherAtk = data.def * 2;
                }
            }

            if(data.race.name === '半人马-西凉铁骑'){
                otherAtk = data.def * 3;
                dd = true;
            }

            return getBaseAtk(otherAtk, true, true, dd, parseFloat2Fiexd(rate));
        },
        atkAfter(){
            if(data.spd < 100){
                if(randomNum(1,100) <= 10){
                    addStatus(data.battleMonster, getStatus('反应不及'))
                }
                addStatus(data, getStatus('减速', { num : 1}))

            }else if(data.spd < 199){
                if(randomNum(1,100) <= 30){
                    addStatus(data.battleMonster, getStatus('反应不及'))
                }
                addStatus(data, getStatus('减速', { num : 2}))

            }else{
                if(randomNum(1,100) <= 50){
                    addStatus(data.battleMonster, getStatus('反应不及'))
                }
                addStatus(data, getStatus('减速', { num : 3}))
            }
            if(getStatuNum(data, '提速') >= 5){
                addStatus(data.battleMonster, getStatus('眩晕', {num : 3}))
            }
            data.spd -= getStatuNum(data, '提速') * 15
            removeStatus(data, '提速')
        },
        text : '半人马种族技能，冲锋后陷入减速状态，无法行动，并有几率给对方附加反应不及状态，使其无法行动，持续1回合。速度加成在1%~99%时，每有1%速度加成，增加2%伤害，有10%概率无视防御，减速状态持续1回合，附加反应不及状态的概率为10%；速度加成在100%~199%时，每有1%速度加成，增加随机2%~3%伤害，有30%概率无视防御，减速状态持续2回合，附加反应不及状态的概率为30%；速度大于等于200%时，每有1%速度加成，增加随机2%~4%伤害，无视防御，减速状态持续3回合，附加反应不及状态的概率为50%；'
    }),
    '技能石：神速' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('神速', true)){
                return false;
            }

            if(getStatuNum(data, '神速')){
                winMsg(`你已经是神速状态了`, false, false);
                return false;
            }

            addStatus(data, getStatus('神速'))
            data.spd += 500;
            addBattleLog(`你使用了神速，速度增加500%，命中率降低30%`)
            return true;
        },
        text : '半人马-白马义从种族技能，给自己附加神速状态，速度提高500%，命中降低30%'
    }),
    '技能石：解除神速' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('解除神速', true)){
                return false;
            }

            if(!getStatuNum(data, '神速')){
                winMsg(`你并不是神速状态`, false, false);
                return false;
            }

            removeStatus(data, '神速')
            data.spd -= 5000;
            addBattleLog(`你解除了神速状态`)
            return true;
        },
        text : '半人马-白马义从种族技能，解除神速状态'
    }),
    '技能石：提速' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('提速', true)){
                return false;
            }

            if(getStatuNum(data, '提速') >= 5){
                winMsg(`你已经是全速前进了`, false, false);
                return false;
            }

            addStatus(data, getStatus('提速'))
            data.spd += 15;
            addBattleLog(`你使用了提速，速度增加15%`)
            return true;
        },
        text : '半人马-重骑兵种族技能，给自己附加提速状态，每有1层提速状态，速度提高15%，最高5层。使用冲锋后消除提速状态。在提速状态为5层时使用冲锋时，100%让对方眩晕3回合。'
    }),

    /*地精系技能*/
    '技能石：埋雷' : new Element({
        canUse :true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('埋雷')){
                return false;
            }

            let ts = data.bag.filter(e => e.name.endsWith('炸药'));
            if(ts.length){
                $('.select-explosive-win').show().find('.select-explosive-win-items').html(`${ts.map(e => `<div data-id="${e.id}">${e.showName || e.name}*${e.quantity}</div>`).join('')}`);
            }else{
                winMsg(`你背包中没有炸药`, false, false);
                return false;
            }

            return true;
        },
        text : '地精种族技能，在当前位置埋下指定类型、指定数量的炸药。每次时间流逝，都有可能被游荡的怪物无意间引爆炸药，每埋藏了1个炸药，引爆概率增加1%。怪物无意间引爆炸药会导致你埋藏的炸药全部被白白触发，你无法获得任何收获'
    }),
    '技能石：引诱' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('引诱', true)){
                return false;
            }

            if(data.buryExplosive[data.world.name] && data.buryExplosive[data.world.name][data.location.join()]) {
                let explosives = data.buryExplosive[data.world.name][data.location.join()];
                let names = Object.keys(explosives);
                if(names.length){
                    let harm = 0;
                    names.forEach(e => {
                        harm += elementCfgs[e].atk * explosives[e];
                    })

                    if(harm > 0){
                        harm = randomNum(parseInt(harm * 0.3), parseInt(harm * 0.6));
                        data.buryExplosive[data.world.name][data.location.join()] = {};

                        data.battleMonster.hp -= reduceShield(data.battleMonster, harm);
                        addBattleLog(`你引爆了埋藏的炸药，${data.battleMonster.showName || data.battleMonster.name}受到了${harm}伤害`)
                        if(harm >= parseInt(data.battleMonster.maxHp * 0.5)){
                            addStatus(data.battleMonster, getStatus('眩晕', {num : 3}))
                        }
                        if(data.battleMonster.hp <= 0){
                            battleWin();
                        }
                    }else{
                        winMsg(`这里没有埋藏炸药或炸药总伤害小于等于0`, false, false);
                        return false;
                    }
                }else{
                    winMsg(`这里没有埋藏炸药`, false, false);
                    return false;
                }
            }else{
                winMsg(`这里没有埋藏炸药`, false, false);
                return false;
            }

            return true;
        },
        text : '地精种族技能，如果当前位置埋了火药，则可以将敌方引诱到火药埋藏点，并引爆火药。本技能会一次性引爆埋下的所有火药，并造成埋下火药本身威力的30%~60%的伤害，本伤害不会再进行20%的随机波动。如果本次伤害让怪物降低了一半以上血量（不是降低到一半以下，是造成的伤害达到怪物血量上限的一半，被怪物护盾抵挡的伤害不算在内），则眩晕怪物3回合。'
    }),
    '技能石：启动备用模式' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 5,
        endurance : 1000,
        voidDust : 0,
        quality : 1,
        gold : 0,
        noSuck : true,
        preFunc : function(weapon) {
            if(!data.mount || !data.mount.name.endsWith('伐木机器人')){
                winMsg('必须驾驶伐木机器人时才能使用', false, false)
                return false;
            }
            return true;
        },
        myAtk : function(){
            return data.mount ? data.mount.endurance : 0;
        },
        atkAfter(){
            const mount = data.mount;
            addStatus(data.battleMonster, getStatus('眩晕', {num : 3}))
            battleOtherAtk(parseInt(data.mount.endurance * 0.2), data, false);
            equipMount(mount);
            reduceItemById(mount.id);
        },
        text : '仅限驾驶伐木机器人时使用。地精们管这叫备用模式，而在大家看来，这就是单纯地自爆而已（说好的爆炸救不了地精呢？）。自爆当前驾驶的机器人，造成机器人当前耐久度*1的伤害，并使敌方眩晕3回合。并对你造成机器人当前耐久度*0.2的伤害(不进行波动，该伤害可被你的减伤和防御减免)'
    }),
    '技能石：地精万岁' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 5,
        endurance : 1000,
        voidDust : 0,
        quality : 1,
        gold : 0,
        noSuck : true,
        preFunc : function(weapon) {
            if(!data.mount || !data.mount.name.endsWith('载弹机器人')){
                winMsg('必须驾驶载弹机器人时才能使用', false, false)
                return false;
            }
            if(!data.mount.yzd){
                winMsg('你驾驶的载弹机器人未装弹', false, false)
                return false;
            }
            return true;
        },
        myAtk : function(){
            return 10000000;
        },
        atkAfter(){
            const mount = data.mount;
            const harm = battleOtherAtk(10000000, data, false);
            equipMount(mount);
            reduceItemById(mount.id);
            addBattleLog(`你受到了会裂开的炸药造成的${harm}伤害`)
            //触发地精万岁的核爆
            nuclearExplosion();
        },
        text : '仅限驾驶载弹机器人，且已装弹时使用。对敌方和自身都造成1000万伤害（防御和减伤可以减免该伤害，虽然没什么意义），且摧毁以当前地图为中心的两格之内的所有地形(即5*5范围，总共25格地形)，将其变为废土，该范围内所有NPC和游荡的神话都会死亡，神殿将被摧毁（不会扣除你的神眷），你的家如果在这一范围内也会被摧毁，仓库物品全部丢失。地图出入口不会受到影响，守关BOSS不受影响，别管为什么，问就是作者之力。'
    }),
    '技能石：装弹' : new Element({
        canUse :true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!data.mount || !data.mount.name.endsWith('载弹机器人')){
                winMsg('必须驾驶载弹机器人时才能使用', false, false)
                return false;
            }
            if(data.mount.yzd){
                winMsg('你驾驶的载弹机器人已装弹', false, false)
                return false;
            }

            let ts = data.bag.filter(e => e.name === '会裂开的炸药');
            if(ts.length){
                let bagItemById = getBagItemById(data.mount.id);
                bagItemById.yzd = true;
                bagItemById.showName = `载弹机器人-已装弹`
                data.mount = bagItemById;
                reduceItem('会裂开的炸药')
                winMsg('装弹完成', false, false)
            }else{
                winMsg(`你背包中没有会裂开的炸药`, false, false);
                return false;
            }

            return true;
        },
        text : '仅限驾驶载弹机器人，且未装弹时使用。将背包中的一个“会裂开的炸药”装在到载弹机器人上面。'
    }),
    '技能石：卸弹' : new Element({
        canUse :true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!data.mount || !data.mount.name.endsWith('载弹机器人')){
                winMsg('必须驾驶载弹机器人时才能使用', false, false)
                return false;
            }
            if(!data.mount.yzd){
                winMsg('你驾驶的载弹机器人未装弹', false, false)
                return false;
            }

            let bagItemById = getBagItemById(data.mount.id);
            bagItemById.yzd = false;
            bagItemById.showName = null
            data.mount = bagItemById;
            addItem('会裂开的炸药')
            winMsg('卸弹完成', false, false)
            return true;
        },
        text : '仅限驾驶载弹机器人，且已装弹时使用。将“会裂开的炸药”从载弹机器人上面卸下。'
    }),

    //狐族系技能
    '技能石：吓唬' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('吓唬', true)){
                return false;
            }
            if(data.battleMonster.xh){
                winMsg('每场战斗只能使用一次',false,false)
                return false;
            }

            data.battleMonster.xh = true;
            if(!data.battleMonster.type && randomNum() <= (100 - (data.battleMonster.level * 3))){
                msg('对方被你吓走了');
                battleEnd();
                setTimeout(function(){timeLapses(battleRunMin);},100)
            }else{
                data.battleMonster.atk += parseInt(data.battleMonster.atk * 0.2)
                addBattleLog('对方没有被你吓住，反而激发了凶性，攻击力提高20%')
            }

            return true;
        },
        text : '狐族种族技能，变成可怕的怪物吓唬敌人，如果吓唬成功，敌人会直接逃跑，结束战斗，但是你无法获得经验和战利品。对普通怪物使用才有可能成功，对精英及以上的怪物使用也允许使用，但是必定会失败。敌人每有1级，成功率降低3%，所以对33级以上的怪物使用一定会失败。如果吓唬失败，敌人会被激发凶性，其攻击力将提高20%。'
    }),
    '技能石：狐火' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 5,
        endurance : 1000,
        voidDust : 0,
        quality : 1,
        gold : 0,
        noSuck : true,
        preFunc : function(weapon) {
            if (!checkRace('狐火', true)) {
                return false;
            }
            const need = 10;
            if(data.hunger < need){
                winMsg('饥饿不足', false, false)
                return false;
            }
            if(data.water < need){
                winMsg('水分不足', false, false)
                return false;
            }
            data.hunger -= need;
            data.water -= need;
            return true;
        },
        myAtk : function(item){
            return getBaseAtk(data.battleMonster ? parseInt(data.battleMonster.def * 0.5) : 0, true, true, false, 1.2);
        },
        text : '狐族-狐妖种族技能，消耗10饥饿和10水分，对敌方造成1.2倍伤害，并无视50%的防御。该技能无法吸血'
    }),
    '技能石：唤灵' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 5,
        endurance : 1000,
        voidDust : 0,
        quality : 1,
        gold : 0,
        noSuck : true,
        preFunc : function(weapon) {
            if (!checkRace('唤灵', true)) {
                return false;
            }
            const need = 50;
            if(data.hunger < need){
                winMsg('饥饿不足', false, false)
                return false;
            }
            if(data.water < need){
                winMsg('水分不足', false, false)
                return false;
            }
            data.hunger -= need;
            data.water -= need;
            return true;
        },
        myAtk : function(item){
            return getBaseAtk(0, true, true, true, 2);
        },
        text : '狐族-狐妖种族技能，消耗50饥饿和50水分，对敌方造成2倍伤害，无视防御。该技能无法吸血'
    }),
    '技能石：迷魂' : new Element({
        canUse :true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if (!checkRace('迷魂', true)) {
                return false;
            }
            const need = 200;
            if(data.hunger < need){
                winMsg('饥饿不足', false, false)
                return false;
            }
            if(data.water < need){
                winMsg('水分不足', false, false)
                return false;
            }
            data.hunger -= need;
            data.water -= need;
            data.safeRun = true;
            return true;
        },
        text : '狐族-狐妖种族技能，消耗200饥饿和200水分，使用后不会被怪物主动攻击，当进行采集或者触发战斗时失效'
    }),
    '技能石：呼风' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('呼风', true)){
                return false;
            }
            const need = 100;
            if(data.hunger < need){
                winMsg('饥饿不足', false, false)
                return false;
            }
            if(data.water < need){
                winMsg('水分不足', false, false)
                return false;
            }
            if(data.battleMonster.hf){
                winMsg('每场战斗只能使用一次',false,false)
                return false;
            }
            data.hunger -= need;
            data.water -= need;
            data.battleMonster.hf = true;

            let def = parseInt(data.battleMonster.def * 0.5);
            if(def < 0){
                def = 0;
            }
            data.battleMonster.def -= def;
            addStatus(data.battleMonster, getStatus('烈风', {harm : def}))
            addBattleLog(`风来！`)

            return true;
        },
        text : '狐族-狐仙种族技能，消耗100饥饿和100水分，将对方防御减半，并给对方附加烈风状态，每回合造成对方因本技能减少的防御力的伤害，该状态不会自动消失。该技能每场战斗只能使用一次'
    }),
    '技能石：唤雨' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 5,
        endurance : 1000,
        voidDust : 0,
        quality : 1,
        gold : 0,
        atkNum : 10,
        noSuck : true,
        preFunc : function(weapon) {
            if (!checkRace('唤雨', true)) {
                return false;
            }
            const need = 20;
            if(data.hunger < need){
                winMsg('饥饿不足', false, false)
                return false;
            }
            if(data.water < need){
                winMsg('水分不足', false, false)
                return false;
            }
            data.hunger -= need;
            data.water -= need;
            return true;
        },
        myAtk : function(item){
            return getBaseAtk(data.level, true, true, false, 0.5);
        },
        atkAfter(){
            if(hasStatus(data.battleMonster,'烈风')){
                removeStatus(data.battleMonster,'烈风');
                addStatus(data.battleMonster, getStatus('风雨交加', {harm : data.battleMonster.def * 2}))
            }
        },
        text : '狐族-狐仙种族技能，消耗20饥饿和20水分，对敌方造成10次0.5倍+你当前等级的伤害。如果对方有烈风状态，则清除对方的烈风状态，给对方附加“风雨交加”状态，每回合造成对方剩余防御力*2的伤害，该状态不会自动消失，该技能无法吸血'
    }),
    '技能石：招雷' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 5,
        endurance : 1000,
        voidDust : 0,
        quality : 1,
        gold : 0,
        noSuck : true,
        preFunc : function(weapon) {
            if (!checkRace('招雷', true)) {
                return false;
            }
            const need = 500;
            if(data.hunger < need){
                winMsg('饥饿不足', false, false)
                return false;
            }
            if(data.water < need){
                winMsg('水分不足', false, false)
                return false;
            }
            if(!hasStatus(data.battleMonster,'风雨交加')){
                winMsg('你应当先呼风唤雨，方能招雷', false, false)
                return false;
            }
            data.hunger -= need;
            data.water -= need;
            return true;
        },
        myAtk : function(item){
            return getBaseAtk(0, true, true, false, 1 + (data.battleMonster ? parseInt((data.battleMonster.maxHp - data.battleMonster.hp) / data.battleMonster.maxHp * 100) : 0));
        },
        text : '狐族-狐仙种族技能，当对方有风雨交加状态时才能使用。消耗500饥饿和500水分，对敌方造成特定倍数的伤害。基础为1倍，对方每损失1%血量，伤害增加1倍。该技能无法吸血'
    }),

    //魅魔公主系技能

    //魅魔公主系技能
    '技能石：魅惑' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('魅惑', true)){
                return false;
            }
            if(randomNum() <= (100)){
                winMsg(`你吸收了${data.battleMonster.name}的精气`);

                let ts = data.blood.filter(e => e.name === data.battleMonster.name);
                if(ts.length){
                    ts[0].num++;
                }else{
                    data.blood.push({
                        name : data.battleMonster.name,
                        num : 10
                    });
                }

                data.exp = 0;
                if(data.weapon && data.weapon.level > data.level){
                    equip(data.weapon)
                }
                if(data.armor && data.armor.level > data.level){
                    equip(data.armor)
                }
                battleEnd();
                setTimeout(() => {
                    timeLapses(battleWinMin);
                }, 10)
                initAttr();
            }else{
                addBattleLog('吸收失败')
            }
            return true;
        },
        text : '魅魔公主种族技能，魅惑敌方，如果成功，则吸收对方的精气，并结束战斗，不会获得战斗奖励。魅惑成功率为：100。该技能可以对所有怪物使用'
    }),
    '技能石：查看气息' : new Element({
        canUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('查看气息', true)){
                return false;
            }
            seeBlood();
            return true;
        },
        text : '魅魔公主种族技能，查看自身拥有的气息'
    }),

    //断肠人系技能
    '技能石：悲怨' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 5,
        endurance : 1000,
        voidDust : 0,
        quality : 1,
        gold : 0,
        preFunc : function(weapon) {
            if (!checkRace('悲怨', true)) {
                return false;
            }
            if(data.soulName !== '泷'){
                winMsg('我应当没有这个能力才是，但……好熟悉', false, false)
                return false;
            }
            if(data.san <= 2){
                winMsg('你的理智不足',false,false)
                return false;
            }
            reduceObjSan(data, 2);
            return true;
        },
        atkAfter(){
            addBattleLog(data.race.says[data.soulName].getRandom());
        },
        myAtk : function(item){
            return getBaseAtk(0, true, true, false, 1 + ((data.maxSan - data.san) * 0.05));
        },
        text : '断肠人种族技能，只有泷才能使用。消耗2点理智，对敌方造成基础为1倍的伤害。当前理智每比理智上限低1点，伤害增加0.05倍。'
    }),
    '技能石：痴念' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if (!checkRace('痴念', true)) {
                return false;
            }
            if(data.soulName !== '鸳'){
                winMsg('鸳……我好想你', false, false)
                return false;
            }
            if(data.san <= 1){
                winMsg('你的理智不足',false,false)
                return false;
            }

            reduceObjSan(data, 1);
            data.reduceHart += 0.15;
            data.cnReduceHart += 0.15;

            addBattleLog(data.race.says[data.soulName].getRandom());
            return true;
        },
        text : '断肠人种族技能，只有鸳才能使用。消耗1点理智，增加3%减伤，可无限叠加。使用该技能时，你的该技能增加的减伤在切换灵魂时会全部失去。'
    }),
    '技能石：癫狂' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 5,
        endurance : 1000,
        voidDust : 0,
        quality : 1,
        gold : 0,
        noSuck : true,
        atkNum : 5,
        preFunc : function(weapon) {
            if (!checkRace('癫狂', true)) {
                return false;
            }
            if(!getStatuNum(data, '心悸')){
                winMsg('你心如死灰', false, false)
                return false;
            }
            return true;
        },
        atkAfter(){
            addBattleLog(data.soulName === '泷' ? '鸳!你在对吗，是你吗鸳？' : '泷，泷！你在哪里？泷！');
            removeStatus(data, '心悸')
            if(data.selfAttrs){
                data.def -= parseInt(data.selfAttrs.def * (data.maxSan - data.san) * 0.02)
            }
            data.san = data.maxSan;
        },
        myAtk : function(item){
            return getBaseAtk(0, true, true, true, (data.maxSan - data.san) * 0.1);
        },
        text : '断肠人种族技能，泷和鸳都能使用，拥有“心悸”状态时才能使用。一瞬间的心悸，你似乎感觉到恋人的存在，似乎你们从未分开过，你不管不顾，只想找到对方。补满理智值，造成5次0倍(即初始无伤害)无视防御的伤害，每因为该技能恢复1点理智，则伤害倍数增加0.1倍，每因为该技能恢复1点理智，防御降低2%（以战斗开始时的防御计算，多次使用该技能可以让自身防御变为负数）。该技能无法吸血'
    }),
    '技能石：肝肠寸断' : new Element({
        canUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if (!checkRace('肝肠寸断', true)) {
                return false;
            }
            if(data.level < 60){
                winMsg('至少60级才可以使用！', false, false);
                return false;
            }
            winMsg(`枯藤老树昏鸦，小桥流水人家，古道西风瘦马，夕阳西下，断肠人在天涯`);
            checkRaceOnceAwaken(data.soulName === '泷' ? '断肠人-独竹' : '断肠人-孤芳');
            return true;
        },
        text : '断肠人种族技能，60级以上才能使用。泷使用该技能将觉醒为“断肠人-独竹”，鸳使用该技能将觉醒为“断肠人-孤芳”，等级回到60级，已有的经验依旧保持不变，并自动进行一次洗点'
    }),
    '技能石：万年霜雪' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if (!checkRace('万年霜雪', true)) {
                return false;
            }
            if(data.san <= 1){
                winMsg('你的理智不足',false,false)
                return false;
            }
            if(data.battleMonster.wnsx){
                winMsg('每场战斗只能使用一次',false,false)
                return false;
            }
            data.battleMonster.wnsx = true;
            reduceObjSan(data, 1);
            addStatus(data.battleMonster, getStatus('万年霜雪', {harm : parseInt(data.atk * (data.maxSan - data.san) * 0.1)}))
            let num = parseInt((data.maxSan - data.san) / 5);
            if(num > 0){
                addStatus(data.battleMonster, getStatus('冰冻', {num}))
            }
            return true;
        },
        text : '断肠人-孤芳种族技能，消耗1点理智，给对方附加万年霜雪状态，每回合造成X(基础倍率为0，当前理智每比最高理智少1点，倍率增加0.1)倍攻击力的伤害，该状态不会自动消失。同时当前理智每比最高理智少5点，则冰冻（使对方无法行动）对方1回合。该技能每场战斗只能使用一次'
    }),
    '技能石：残花落尽' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if (!checkRace('残花落尽', true)) {
                return false;
            }
            if(data.san <= 10){
                winMsg('你的理智不足',false,false)
                return false;
            }
            if(data.battleMonster.chlj){
                winMsg('每场战斗只能使用一次',false,false)
                return false;
            }
            data.battleMonster.chlj = true;
            reduceObjSan(data, 10);
            addStatus(data, getStatus('冷静'))
            return true;
        },
        text : '断肠人-孤芳种族技能，消耗10点理智，给自己附加“冷静”状态，使自己不会因为理智原因陷入疯狂，持续10回合。该技能每场战斗只能使用一次'
    }),
    '技能石：疯魔' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 5,
        endurance : 1000,
        voidDust : 0,
        quality : 1,
        gold : 0,
        noSuck : true,
        getAtkNum : function(){
            return data.san - 1;
        },
        preFunc : function(weapon) {
            if (!checkRace('疯魔', true)) {
                return false;
            }
            if(data.san <= 1){
                winMsg('你的理智不足',false,false)
                return false;
            }
            return true;
        },
        myAtk : function(item){
            return getBaseAtk(0, true, true, true, 1);
        },
        atkAfter(){
            data.san = 1;
        },
        text : '断肠人-红煞种族技能，消耗所有理智，只保留1点，消耗了多少理智，就造成多少次1倍攻击且无视防御的伤害'
    }),
    '技能石：心茫然' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if (!checkRace('心茫然', true)) {
                return false;
            }
            if(data.san <= 1){
                winMsg('你的理智不足',false,false)
                return false;
            }
            reduceObjSan(data, 1);
            let addHp = this.myHp();
            const text = `你使用了心茫然，恢复${battleAddHp(data, addHp)}HP`;
            addStatus(data.battleMonster, getStatus('茫然'))
            addBattleLog(text)
            return true;
        },
        myHp : function(){
            return parseInt(data.maxHp * 0.1);
        },
        text : '断肠人-独竹种族技能，消耗1点理智，恢复10%生命值，并给对方附加茫然状态，使其无法行动，持续1回合'
    }),
    '技能石：崩灵' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if (!checkRace('崩灵', true)) {
                return false;
            }
            if(data.san <= 1){
                winMsg('你的理智不足',false,false)
                return false;
            }
            addStatus(data.battleMonster, getStatus('茫然', {num : data.san - 1}))
            data.san = 1;
            return true;
        },
        text : '断肠人-黑邪种族技能，消耗所有理智，只保留1点，消耗了多少理智，就给对方附加多少回合的茫然状态，使其无法行动'
    }),
    '技能石：风月情浓' : new Element({
        canUse :true,
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        func : function(){
            if(!checkRace('风月情浓', true)){
                return false;
            }
            if(data.san <= 1){
                winMsg('你的理智不足',false,false)
                return false;
            }
            if(inBattle() && data.battleMonster.fyqn){
                winMsg('每场战斗只能使用一次',false,false)
                return false;
            }
            reduceObjSan(data, 1);
            if(inBattle()){
                data.battleMonster.fyqn = true;
                battleAddHp(data, this.myHp ? this.myHp() : elementCfgs[this.name].myHp());
            }else{
                this.hp = this.maxHp;
            }

            const text = `使用了风月情浓，生命值完全恢复`;
            msg(text);
            addBattleLog(text)
            return true;
        },
        myHp : function(){
            return data.maxHp;
        },
        text : '断肠人-花魂种族技能，消耗1点理智，恢复全部生命值'
    }),
    '技能石：死生契阔' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 5,
        endurance : 1000,
        voidDust : 0,
        quality : 1,
        gold : 0,
        atkNum : 2,
        preFunc : function(weapon) {
            if (!checkRace('死生契阔', true)) {
                return false;
            }
            return true;
        },
        myAtk : function(item){
            return getBaseAtk(0, true, true, false, 1 + ((data.maxSan - data.san) * 0.01));
        },
        text : '断肠人-花魂种族技能，造成2次伤害，当前理智每比理智上限低1点，伤害增加1%'
    }),

    //天使系技能
    '技能石：混沌审判' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if (!checkRace('混沌审判', true)) {
                return false;
            }
            if(data.evil < 10 && data.evil > -10){
                winMsg('你的善良值/邪恶值不足',false,false)
                return false;
            }

            //善良阵营使用
            if(data.evil < 0){
                if(hasStatus(data, '不灭')){
                    winMsg('你已经拥有不灭状态',false,false)
                    return false;
                }
                //这里因为是固定-10善良，所以不调用addEvil
                addStatus(data, getStatus('不灭'))
                addBattleLog(`你使用了混沌审判，获得了不灭状态`)
            }else{//邪恶阵营使用
                if(hasStatus(data, '杀欲')){
                    winMsg('你已经拥有杀欲状态',false,false)
                    return false;
                }
                //这里因为是固定-10邪恶，所以不调用addEvil
                data.atk += data.level * 3;
                addBattleLog(`你使用了混沌审判，获得了${data.level * 3}攻击力`)
                addStatus(data, getStatus('杀欲'))
            }

            return true;
        },
        text : '天使-混沌种族技能，当前为邪恶阵营时消耗10点邪恶值，给自己附加“杀欲”状态，攻击力增加你当前等级的3倍当你失去杀欲状态时，增加的攻击力会扣除。杀欲状态每回合会消耗你10点邪恶值，当你的邪恶值足够10点时，杀欲状态不会随着回合结束自动减少层数，当你的邪恶值不足10点，则杀欲状态消失。当你为善良阵营时，消耗10点善良值，给自己附加“不灭”状态，拥有不灭状态时，如果你的生命值上限大于0，则你的生命值至少会保留1点，不会死亡。不灭状态每回合会消耗你10点善良值，当你的善良值足够10点时，不灭状态不会随着回合结束自动减少层数，当你的善良值不足10点，则不灭状态消失。'
    }),
    '技能石：阵营转换' : new Element({
        canUse : true,
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if (!checkRace('阵营转换', true)) {
                return false;
            }

            if(data.evil === 0){
                winMsg('你当前为中立阵营，无法转换阵营',false,false)
                return false;
            }

            data.evil = -data.evil;
            addBattleLog(`你的阵营转为了${getPlayerCamp()}`)
            winMsg(`你的阵营转为了${getPlayerCamp()}`)

            return true;
        },
        text : '天使-伪神种族技能，不为中立阵营时才能使用。如果当前是善良阵营，善良点数变为等值的邪恶点数，阵营转为邪恶阵营。如果当前是邪恶阵，邪恶点数变为等值的善良点数，阵营转为善良阵营。'
    }),

    //魔术师系技能
    ...getBatchItem(['碎裂','裂开','完整','无瑕','完美','璀璨'], function(name){
        const level = gemNames.filter(e => e.name === `${name}的`)[0].level;

        return {
            [`技能石：宝石阵_${name}`] : new Element({
                battleUse : true,
                weight : 0,
                voidDust : 0,
                quality : 1,
                gold : 0,
                func : function(){
                    if (!checkRace(`宝石阵_${name}`, true)) {
                        return false;
                    }

                    if(hasStatus(data, `${name}阵`)){
                        winMsg(`身上没有“${name}阵”状态才能使用`,false,false)
                        return false;
                    }

                    if(data.level < level){
                        winMsg(`${level}级以上才能使用`,false,false)
                        return false;
                    }

                    //判断是否有其他宝石阵状态
                    let filter = data.status.filter(e => e.name.endsWith('阵') && e.name.length === 3);
                    //有的话，归还宝石
                    if(filter.length){
                        //获取状态名
                        const name = filter[0].name;
                        //获取宝石类型
                        let type = name.replace('阵', '');
                        //获取所有宝石状态
                        let gems = data.status.filter(e => e.name.endsWith('宝石') && e.name.length === 3);
                        //循环获取宝石，并删除状态
                        gems.forEach(e => {
                            let gemColor = e.name.replace('宝石', '');
                            if(gemColor === '橙'){
                                gemColor = '橙色';
                            }
                            addItem(`${type}的${gemColor}宝石`, e.num);
                            removeStatus(data, e.name);
                        })
                        //删除宝石阵状态
                        removeStatus(data, name);
                    }

                    addBattleLog(`你展开了${name}阵`)
                    addStatus(data, getStatus(`${name}阵`))

                    return true;
                },
                text : `魔术师种族技能，${level}级以上才能使用，身上没有“${name}阵”状态才能使用。如果身上没有其他宝石阵的状态，即可获得“${name}阵”状态。如果身上有其他宝石阵的状态，则将那个状态移除，然后将所有“X宝石”状态移除，归还用于附加“X宝石”状态所消耗的对应数量的宝石，并获得“${name}阵”状态。${name}阵状态不会自动减少`
            })
        }
    }),
    ...getBatchItem(['红','黄','紫','绿','橙'], function(name){
        return {
            [`技能石：${name}宝石镶嵌`] : new Element({
                battleUse : true,
                weight : 0,
                voidDust : 0,
                quality : 1,
                gold : 0,
                func : function(){
                    if (!checkRace(`${name}宝石镶嵌`, true)) {
                        return false;
                    }

                    if(!data.status.filter(e => e.name.endsWith('阵') && e.name.length === 3).length){
                        winMsg(`请先设定一个宝石阵`,false,false)
                        return false;
                    }

                    //获取宝石品质
                    let type = data.status.filter(e => e.name.endsWith('阵') && e.name.length === 3)[0].name.replace('阵', '');
                    let gemColor = name === '橙' ? name + '色' : name;

                    if(!getNumByBag(`${type}的${gemColor}宝石`, data.location.join() === data.world.home.location.join())){
                        winMsg(`需要消耗1个${type}的${gemColor}宝石`,false,false);
                        return false;
                    }

                    //消耗宝石
                    reduceItemByAll(`${type}的${gemColor}宝石`)
                    //添加状态
                    addStatus(data, getStatus(`${name}宝石`))
                    addBattleLog(`你给宝石阵镶嵌了一个${name}宝石`)

                    return true;
                },
                text : `魔术师种族技能，需要先设置宝石阵才能使用。消耗1个和宝石阵对应品质的${name}宝石，给自己增加1层“${name}宝石”状态，该状态不会自动消失，可以无限累加。该技能消耗的宝石在切换宝石阵时会归还，因为状态被清除或者战斗结束时都不会归还。`
            })
        }
    }),
    '技能石：火焰魔术' : new Element({
        onlyOne :true,
        isWeapon : true,
        endurance : 1000,
        weight : 5,
        noSuck : true,
        voidDust : 0,
        quality : 1,
        gold : 0,
        preFunc : function(weapon){
            if(!checkRace('火焰魔术', true)){
                return false;
            }

            if(!data.status.filter(e => e.name.endsWith('阵') && e.name.length === 3).length){
                winMsg(`请先设定一个宝石阵`,false,false)
                return false;
            }

            let rate = checkGemNum({红:1,黄:1,橙:1});

            if(rate === -1){
                winMsg('宝石镶嵌错误，需要【红:黄:橙=1:1:1】', false, false)
                return;
            }

            return true;
        },
        atkAfter(){
            //添加燃烧状态
            addStatus(data.battleMonster, getStatus('燃烧', {harm : this.getAtk(this), num : getQualityBaseNum() * 2}))
            //魔术完成
            magicOver()
        },
        myAtk : function(){
            //倍率加值
            const rate = checkGemNum({红:1,黄:1,橙:1});
            return getFinalNum(getBaseAtk(0, true, true, false, rate + 1), ['红', '黄', '橙']);
        },
        text : '魔术师种族技能，需要宝石阵上镶嵌宝石的比例为【红:黄:橙=1:1:1】，不允许镶嵌其他颜色的宝石。该魔术造成【基础伤害*(1+倍率加值)*最终效果】的伤害，并给对方附加燃烧状态，每回合都造成和等同于输出值的伤害，持续【品质基数*2】回合。该技能无法触发吸血'
    }),
    '技能石：冰霜魔术' : new Element({
        onlyOne :true,
        isWeapon : true,
        endurance : 1000,
        weight : 5,
        noSuck : true,
        voidDust : 0,
        quality : 1,
        gold : 0,
        preFunc : function(weapon){
            if(!checkRace('冰霜魔术', true)){
                return false;
            }

            if(!data.status.filter(e => e.name.endsWith('阵') && e.name.length === 3).length){
                winMsg(`请先设定一个宝石阵`,false,false)
                return false;
            }

            let rate = checkGemNum({紫:1,绿:1,橙:1});

            if(rate === -1){
                winMsg('宝石镶嵌错误，需要【紫:绿:橙=1:1:1】', false, false)
                return;
            }

            return true;
        },
        atkAfter(){
            //倍率加值
            const rate = checkGemNum({紫:1,绿:1,橙:1});
            //添加冰冻状态
            addStatus(data.battleMonster, getStatus('冰冻', {num : rate * 2 + 2}))
            //魔术完成
            magicOver()
        },
        myAtk : function(){
            return getFinalNum(getBaseAtk(0, true, true, false, getQualityBaseNum() * 0.3), ['紫', '绿', '橙']);
        },
        text : '魔术师种族技能，需要宝石阵上镶嵌宝石的比例为【紫:绿:橙=1:1:1】，不允许镶嵌其他颜色的宝石。该魔术造成【基础伤害*品质基数*0.3*最终效果】的伤害，并给对方附加冰冻状态，使敌方无法行动，持续【2 + (倍率加值*2)】回合。该技能无法触发吸血'
    }),
    '技能石：彩虹魔术' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('彩虹魔术', true)){
                return false;
            }

            if(!data.status.filter(e => e.name.endsWith('阵') && e.name.length === 3).length){
                winMsg(`请先设定一个宝石阵`,false,false)
                return false;
            }

            //倍率加值
            let rate = checkGemNum({红:1,黄:1,紫:1,绿:1,橙:1});
            if(rate === -1){
                winMsg('宝石镶嵌错误，需要【红:黄:紫:绿:橙=1:1:1:1:1】', false, false)
                return;
            }

            //品质基数
            let qualityBaseNum = getQualityBaseNum();
            //已有生命值
            const hp = data.hp;
            //已损失生命值
            const reduceHp = data.maxHp - data.hp;

            if(hp === reduceHp){
                winMsg('当前血量和已损失血量相同时无法使用', false, false)
                return;
            }
            if(reduceHp == 0){
                winMsg('满血时无法使用', false, false)
                return;
            }

            //回血
            if(reduceHp > hp){
                data.hp = reduceHp;
                //回血量
                const addNum = reduceHp - hp;
                //增加的护盾
                let finalNum = getFinalNum(addNum * (rate + 1), ['红','黄','紫','绿','橙']);
                data.shield += finalNum;
                addBattleLog(`你使用了彩虹魔术，恢复${battleAddHp(data, addNum)}生命值，并获得${finalNum}护盾`)
            }else{//扣血
                data.hp = data.maxHp - hp;
                //扣血量
                const reduceNum = hp - reduceHp;
                //减少的生命上限
                let finalNum = getFinalNum(reduceNum * (rate + 1) * 0.2 * qualityBaseNum, ['红','黄','紫','绿','橙']);
                data.battleMonster.maxHp -= finalNum;
                addObjHp(data.battleMonster, 0);
                addBattleLog(`你使用了彩虹魔术，损失了${reduceNum}生命值，并使${data.battleMonster.showName || data.battleMonster.name}减少了${finalNum}生命上限`)
            }

            //魔术完成
            magicOver()

            return true;
        },
        text : '魔术师-光影种族技能，需要宝石阵上镶嵌宝石的比例为【红:黄:紫:绿:橙=1:1:1:1:1】。当前血量和已损失血量相同时无法使用，满血时无法使用。将自身的当前血量和已损失血量互换，每因为此效果恢复1点生命值，获得【恢复生命值*(倍率加值 + 1)*最终效果】的护盾；每因为此效果损失1点生命值，减少对方相当于【损失生命值*(倍率加值 + 1)*0.2*品质基数*最终效果】的生命上限'
    }),
    '技能石：极光魔术' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('极光魔术', true)){
                return false;
            }

            if(!data.status.filter(e => e.name.endsWith('阵') && e.name.length === 3).length){
                winMsg(`请先设定一个宝石阵`,false,false)
                return false;
            }

            //倍率加值
            let rate = checkGemNum({红:35,黄:26,紫:18,绿:22,橙:21});
            if(rate === -1){
                winMsg('宝石镶嵌错误，需要【红:黄:紫:绿:橙=35:26:18:22:21】', false, false)
                return;
            }

            //品质基数
            let qualityBaseNum = getQualityBaseNum();

            //玩家的HP要变成多少
            const playerHp = data.battleMonster.hp > data.maxHp ? getFinalNum(data.maxHp, ['红','黄','紫','绿','橙']) : getFinalNum(data.battleMonster.hp, ['红','黄','紫','绿','橙']);
            //怪物的HP要变成多少
            const monsterHp = data.hp * 2 - (getFinalNum(data.hp, ['红','黄','紫','绿','橙']));
            data.hp = playerHp;
            data.battleMonster.hp = monsterHp;
            //要眩晕的回合
            const num = 10 - rate - qualityBaseNum;

            if(num > 0){
                addStatus(data, getStatus('眩晕', {num}))
            }

            addBattleLog(`你使用了极光魔术，双方生命值发生翻转`)

            //魔术完成
            magicOver()

            return true;
        },
        text : '魔术师-璀璨种族技能，需要宝石阵上镶嵌宝石的比例为【红:黄:紫:绿:橙=35:26:18:22:21】。怪物生命值变为【你的当前生命值*(2-最终效果)】，你的生命值变为【怪物的当前生命值*最终效果】，如果怪物的当前生命值比你的生命上限还要高，则你的生命值变为【你的生命上限*最终效果】，并使自己眩晕【10-倍率加值-品质基数】回合，如果回合数小于等于0则不眩晕。'
    }),
    '技能石：爆炸魔术' : new Element({
        onlyOne :true,
        isWeapon : true,
        endurance : 1000,
        weight : 5,
        noSuck : true,
        voidDust : 0,
        quality : 1,
        gold : 0,
        preFunc : function(weapon){
            if(!checkRace('爆炸魔术', true)){
                return false;
            }

            if(!data.status.filter(e => e.name.endsWith('阵') && e.name.length === 3).length){
                winMsg(`请先设定一个宝石阵`,false,false)
                return false;
            }

            let rate = checkGemNum({红:3,黄:2,紫:1,绿:1,橙:2});

            if(rate === -1){
                winMsg('宝石镶嵌错误，需要【红:黄:紫:绿:橙=3:2:1:1:2】', false, false)
                return;
            }

            return true;
        },
        atkAfter(){
            //倍率加值
            const rate = checkGemNum({红:3,黄:2,紫:1,绿:1,橙:2});
            //添加燃烧状态
            addStatus(data.battleMonster, getStatus('眩晕', {num : (rate + getQualityBaseNum()) * 2}))
            //魔术完成
            magicOver()
        },
        myAtk : function(){
            //倍率加值
            const rate = checkGemNum({红:3,黄:2,紫:1,绿:1,橙:2});
            return getFinalNum(getBaseAtk(0, true, true, false, getQualityBaseNum() * (rate + 1)), ['红','黄','紫','绿','橙']);
        },
        text : '魔术师-塑能种族技能，需要宝石阵上镶嵌宝石的比例为【红:黄:紫:绿:橙=3:2:1:1:2】。该魔术造成【基础伤害*(1+倍率加值)*品质基数*最终效果】的伤害，并使对方眩晕【(倍率加值+品质基数)*2】回合。该技能无法触发吸血'
    }),
    '技能石：陨石魔术' : new Element({
        onlyOne :true,
        isWeapon : true,
        endurance : 1000,
        weight : 5,
        noSuck : true,
        voidDust : 0,
        quality : 1,
        gold : 0,
        preFunc : function(weapon){
            if(!checkRace('陨石魔术', true)){
                return false;
            }

            if(!data.status.filter(e => e.name.endsWith('阵') && e.name.length === 3).length){
                winMsg(`请先设定一个宝石阵`,false,false)
                return false;
            }

            let rate = checkGemNum({红:30,黄:55,紫:12,绿:5,橙:27});

            if(rate === -1){
                winMsg('宝石镶嵌错误，需要【红:黄:紫:绿:橙=30:55:12:5:27】', false, false)
                return;
            }

            return true;
        },
        atkAfter(){
            //魔术完成
            magicOver()
        },
        myAtk : function(){
            //倍率加值
            let rate = checkGemNum({红:30,黄:55,紫:12,绿:5,橙:27});
            if(rate < 0){
                rate = 0;
            }
            return data.battleMonster ? getFinalNum(parseInt(data.battleMonster.maxHp * (0.1 + ((rate) * 0.2) + (getQualityBaseNum() * 0.1))), ['红','黄','紫','绿','橙']) : 0;
        },
        text : '魔术师-掌控种族技能，需要宝石阵上镶嵌宝石的比例为【红:黄:紫:绿:橙=30:55:12:5:27】。该魔术造成【怪物生命值上限*（0.1 + (倍率加值*0.2) + (品质基数 * 0.1))*最终效果】的伤害。该技能无法触发吸血'
    }),
    //['红','黄','紫','绿','橙']
};

//魔术师获取品质基数
function getQualityBaseNum(quality){
    const filter = data.status.filter(e => e.name.endsWith('阵') && e.name.length === 3);
    if(filter.length){
        quality = filter[0].name.replace('阵','');
    }
    return ['碎裂','裂开','完整','无瑕','完美','璀璨'].indexOf(quality) + 1;
}

//魔术师获取最终效果
function getFinalNum(harm, colors = []){
    if(!data.usedGems){
        data.usedGems = {};
    }

    //宝石类型
    let type = null;
    //获取宝石阵状态
    let filter = data.status.filter(e => e.name.endsWith('阵') && e.name.length === 3);
    //有的话，归还宝石
    if(filter.length){
        //获取状态名
        const name = filter[0].name;
        //获取宝石类型
        type = name.replace('阵', '');
    }

    if(!type){
        return harm;
    }

    let count = colors.length * 1000;
    colors.forEach(e => {
        count -= data.usedGems[type + e] || 0;
    })

    if(count < 0){
        count = 0;
    }

    return parseInt(harm * count / (colors.length * 1000));
}

//魔术师魔术完成
function magicOver(){
    if(!data.usedGems){
        data.usedGems = {};
    }
    //获取宝石阵状态
    let filter = data.status.filter(e => e.name.endsWith('阵') && e.name.length === 3);
    //有的话，归还宝石
    if(filter.length){
        //获取状态名
        const name = filter[0].name;
        //获取宝石类型
        let type = name.replace('阵', '');
        //获取所有宝石状态
        let gems = data.status.filter(e => e.name.endsWith('宝石') && e.name.length === 3);
        //循环获取宝石，并删除状态
        gems.forEach(e => {
            let gemColor = e.name.replace('宝石', '');
            const usedName = type + gemColor;

            //增加使用个数
            if(!data.usedGems[usedName]){
                data.usedGems[usedName] = 0;
            }
            data.usedGems[usedName] += e.num;

            //删除宝石状态
            removeStatus(data, e.name);
        })
        //删除宝石阵状态
        removeStatus(data, name);
    }
}

//魔术师判断宝石是否符合要求，返回-1则说明不符合要求，符合要求则返回倍率加值
function checkGemNum(ask = {}){
    const {红 = 0, 黄 = 0, 紫 = 0, 绿 = 0, 橙 = 0} = ask;
    //获取所有宝石状态
    let gems = data.status.filter(e => e.name.endsWith('宝石') && e.name.length === 3);
    if(!gems.length){
        return -1;
    }
    //获取一个有状态的宝石名字
    const oneColor = gems[0].name[0];

    //有这个状态，但是没这个要求，则不符合
    if(!ask[oneColor]){
        return -1;
    }

    //计算出倍率
    const rate = gems[0].num / ask[oneColor];

    //倍率不是整数则不符合
    if(!Number.isInteger(rate)){
        return -1;
    }

    for(const color in ask){
        //获取已有数量
        const filter = data.status.filter(e => e.name === `${color}宝石`);
        let hasNum = 0;
        if(filter.length){
            hasNum = filter[0].num;
        }

        //如果有状态，无要求，则不符合
        if(!ask[color] && hasNum){
            return -1;
        }
        //如果无状态，有要求，则不符合
        if(ask[color] && !hasNum){
            return -1;
        }
        //如果倍率乘以要求不等于状态数，则不符合
        if(rate * ask[color] !== hasNum){
            return -1;
        }
    }

    //返回倍率
    return rate - 1;
}

//魅魔公主的查看精气
function seeBlood(){
    if(data.blood.filter(e => monsterCfgs[e.name]).length){
        const allKey = Object.keys(monsterCfgs);
        const el = $('.common-win').show().find('.win-body');
        el.html(data.blood.filter(e => monsterCfgs[e.name]).sort((a,b) => allKey.indexOf(a.name) - allKey.indexOf(b.name)).map(e => `<div style="padding: 5px 10px">${e.name}(${e.num}%)：+${parseInt(monsterCfgs[e.name].atk * e.num / 100)}攻击，+${parseInt(monsterCfgs[e.name].def * e.num / 100)}防御，+${parseInt(monsterCfgs[e.name].hp * e.num / 1000)}HP</div>`).join(''));

        let allHas = data.blood.map(e => e.name);
        el.append(Object.keys(monsterCfgs).filter(e => !allHas.includes(e)).map(e => `<div style="padding: 5px 10px">${e}：未吸收</div>`).join(''));
    }else{
        winMsg(`你没有吸收过精气`, false, false)
    }
}

//地精万岁的核爆
function nuclearExplosion(){
    //获取到所有有效坐标
    const points = [];
    const [xp, yp] = data.location;
    for(let x = -2 ; x <= 2 ; x++){
        for(let y = -2 ; y <= 2 ; y++){
            const thisx = xp + x;
            const thisy = yp + y;
            if(thisx >= 0 && thisx < xnum && thisy >= 0 && thisy < xnum && (!data.nextPoint || `${thisx},${thisy}` !== data.nextPoint.join()) && (!data.prePoint || `${thisx},${thisy}` !== data.prePoint.join())){
                points.push([thisx,thisy])
            }
        }
    }

    let log = `会裂开的炸药爆炸了，摧毁了${points.length}个地形`;

    //循环销毁地形
    points.forEach(e => {
        //摧毁神殿
        if(data.temples[data.worldIndex][e.join()]){
            log += `，${data.temples[data.worldIndex][e.join()].name}被摧毁了`;
            delete data.temples[data.worldIndex][e.join()];
        }
        //杀死神话怪
        const myths = data.world.mythMonster.filter(m => m.location.join() === e.join());
        if(myths.length > 0){
            myths.forEach(m => {
                log += `，${m.name}被杀死了`;
                m.deathTime = new Date(data.date).getTime();
            })
        }
        //杀死NPC
        if(data.world.npcs){
            data.world.npcs.filter(n => n.location.join() === e.join()).forEach(n => {
                log += `，${n.name}被杀死了`;
            })
            data.world.npcs = data.world.npcs.filter(n => n.location.join() !== e.join())
        }
        //摧毁家
        if(data.world.home.location.join() === e.join()){
            log += '，你的家被摧毁了';
            data.world.home = {
                location : [],
                store : [],
            }
        }
        //摧毁地形
        data.map[e[1]][e[0]] = '废土';
        data.world.map[e[1]][e[0]] = '废土';
        data.world.mapElements[e.join()] = {
            elementList : [],
            monsterList : [],
            renderDates : {}
        }
    })

    winMsg(log);
    addBattleLog(log)
    renderMapElements(false, true)
    renderCanToMap();
}
