//副本配置
const dungeons = {
    '深渊' : {
        name : '深渊',
        map : '血战',
        type : 1,//副本类型，1=每个怪物刷一次，2=无线模式副本，3=怪物无限刷新的副本
        level : [1,1000],//世界等级
        worldBoss : '无',//世界BOSS，即守关BOSS
        mythMonster : [],//神话怪
    },
    '道馆第一层' : {
        name : '道馆第一层',
        map : '道馆第一层',
        type : 1,//副本类型，1=每个怪物刷一次，2=无线模式副本，3=怪物无限刷新的副本
        level : [1,1000],//世界等级
        worldBoss : '无',//世界BOSS，即守关BOSS
        mythMonster : ['玛力露丽'],//神话怪
    },
    '道馆第二层' : {
        name : '道馆第二层',
        map : '道馆第二层',
        type : 1,//副本类型，1=每个怪物刷一次，2=无线模式副本，3=怪物无限刷新的副本
        level : [1,1000],//世界等级
        worldBoss : '无',//世界BOSS，即守关BOSS
        mythMonster : ['美纳斯'],//神话怪
    },
    '道馆第三层' : {
        name : '道馆第三层',
        map : '道馆第三层',
        type : 1,//副本类型，1=每个怪物刷一次，2=无线模式副本，3=怪物无限刷新的副本
        level : [1,1000],//世界等级
        worldBoss : '无',//世界BOSS，即守关BOSS
        mythMonster : ['电击魔兽'],//神话怪
    },
    '道馆第四层' : {
        name : '道馆第四层',
        map : '道馆第四层',
        type : 1,//副本类型，1=每个怪物刷一次，2=无线模式副本，3=怪物无限刷新的副本
        level : [1,1000],//世界等级
        worldBoss : '无',//世界BOSS，即守关BOSS
        mythMonster : ['索罗亚'],//神话怪
    },
    '道馆第五层' : {
        name : '道馆第五层',
        map : '道馆第五层',
        type : 1,//副本类型，1=每个怪物刷一次，2=无线模式副本，3=怪物无限刷新的副本
        level : [1,1000],//世界等级
        worldBoss : '无',//世界BOSS，即守关BOSS
        mythMonster : ['急冻鸟'],//神话怪
    },
    '道馆第六层' : {
        name : '道馆第六层',
        map : '道馆第六层',
        type : 1,//副本类型，1=每个怪物刷一次，2=无线模式副本，3=怪物无限刷新的副本
        level : [1,1000],//世界等级
        worldBoss : '无',//世界BOSS，即守关BOSS
        mythMonster : ['炽焰咆哮虎'],//神话怪
    },
    '道馆第七层' : {
        name : '道馆第七层',
        map : '道馆第七层',
        type : 1,//副本类型，1=每个怪物刷一次，2=无线模式副本，3=怪物无限刷新的副本
        level : [1,1000],//世界等级
        worldBoss : '无',//世界BOSS，即守关BOSS
        mythMonster : ['妙蛙花'],//神话怪
    },
    '道馆第八层' : {
        name : '道馆第八层',
        map : '道馆第八层',
        type : 1,//副本类型，1=每个怪物刷一次，2=无线模式副本，3=怪物无限刷新的副本
        level : [1,1000],//世界等级
        worldBoss : '无',//世界BOSS，即守关BOSS
        mythMonster : ['耿鬼'],//神话怪
    },
    '道馆第九层' : {
        name : '道馆第九层',
        map : '道馆第九层',
        type : 1,//副本类型，1=每个怪物刷一次，2=无线模式副本，3=怪物无限刷新的副本
        level : [1,1000],//世界等级
        worldBoss : '无',//世界BOSS，即守关BOSS
        mythMonster : ['宝贝龙'],//神话怪
    },
    '道馆第十层' : {
        name : '道馆第十层',
        map : '道馆第十层',
        type : 1,//副本类型，1=每个怪物刷一次，2=无线模式副本，3=怪物无限刷新的副本
        level : [1,1000],//世界等级
        worldBoss : '无',//世界BOSS，即守关BOSS
        mythMonster : ['超梦'],//神话怪
    },
    '究极之洞第一层' : {
        name : '究极之洞第一层',
        map : '究极之洞第一层',
        type : 1,//副本类型，1=每个怪物刷一次，2=无线模式副本，3=怪物无限刷新的副本
        level : [1,10000],//世界等级
        worldBoss : '无',//世界BOSS，即守关BOSS
        mythMonster : ['恶食大王'],//神话怪
    },
    '究极之洞第二层' : {
        name : '究极之洞第二层',
        map : '究极之洞第二层',
        type : 1,//副本类型，1=每个怪物刷一次，2=无线模式副本，3=怪物无限刷新的副本
        level : [1,10000],//世界等级
        worldBoss : '无',//世界BOSS，即守关BOSS
        mythMonster : ['索尔迦雷欧'],//神话怪
    },
    '究极之洞第三层' : {
        name : '究极之洞第三层',
        map : '究极之洞第三层',
        type : 1,//副本类型，1=每个怪物刷一次，2=无线模式副本，3=怪物无限刷新的副本
        level : [1,10000],//世界等级
        worldBoss : '无',//世界BOSS，即守关BOSS
        mythMonster : ['纸御剑'],//神话怪
    },
    '究极之洞第四层' : {
        name : '究极之洞第四层',
        map : '究极之洞第四层',
        type : 1,//副本类型，1=每个怪物刷一次，2=无线模式副本，3=怪物无限刷新的副本
        level : [1,10000],//世界等级
        worldBoss : '无',//世界BOSS，即守关BOSS
        mythMonster : ['费洛美螂'],//神话怪
    },
    '究极之洞第五层' : {
        name : '究极之洞第五层',
        map : '究极之洞第五层',
        type : 1,//副本类型，1=每个怪物刷一次，2=无线模式副本，3=怪物无限刷新的副本
        level : [1,10000],//世界等级
        worldBoss : '无',//世界BOSS，即守关BOSS
        mythMonster : ['百变怪'],//神话怪
    },
    '究极之洞第六层' : {
        name : '究极之洞第六层',
        map : '究极之洞第六层',
        type : 1,//副本类型，1=每个怪物刷一次，2=无线模式副本，3=怪物无限刷新的副本
        level : [1,10000],//世界等级
        worldBoss : '无',//世界BOSS，即守关BOSS
        mythMonster : ['露奈雅拉'],//神话怪
    },
    '究极之洞第七层' : {
        name : '究极之洞第七层',
        map : '究极之洞第七层',
        type : 1,//副本类型，1=每个怪物刷一次，2=无线模式副本，3=怪物无限刷新的副本
        level : [1,10000],//世界等级
        worldBoss : '无',//世界BOSS，即守关BOSS
        mythMonster : ['爆肌蚊'],//神话怪
    },
    '究极之洞第八层' : {
        name : '究极之洞第八层',
        map : '究极之洞第八层',
        type : 1,//副本类型，1=每个怪物刷一次，2=无线模式副本，3=怪物无限刷新的副本
        level : [1,10000],//世界等级
        worldBoss : '无',//世界BOSS，即守关BOSS
        mythMonster : ['·黑暗·究极·由克希'],//神话怪
    },
    '究极之洞第九层' : {
        name : '究极之洞第九层',
        map : '究极之洞第九层',
        type : 1,//副本类型，1=每个怪物刷一次，2=无线模式副本，3=怪物无限刷新的副本
        level : [1,10000],//世界等级
        worldBoss : '无',//世界BOSS，即守关BOSS
        mythMonster : ['黑暗·究极·莱希拉姆'],//神话怪
    },
    '究极之洞第十层' : {
        name : '究极之洞第十层',
        map : '究极之洞第十层',
        type : 1,//副本类型，1=每个怪物刷一次，2=无线模式副本，3=怪物无限刷新的副本
        level : [1,20000],//世界等级
        worldBoss : '无',//世界BOSS，即守关BOSS
        mythMonster : ['小萝莉幻影'],//神话怪
    },
    '究极之洞·守层' : {
        name : '究极之洞·守层',
        map : '究极之洞·守层',
        type : 1,//副本类型，1=每个怪物刷一次，2=无线模式副本，3=怪物无限刷新的副本
        level : [1000,20000],//世界等级
        worldBoss : '无',//世界BOSS，即守关BOSS
        mythMonster : ['黑暗·究极·蒂安希'],//神话怪
    },
    '异世界·虚无层' : {
        name : '异世界·虚无层',
        map : '异世界·虚无层',
        type : 1,//副本类型，1=每个怪物刷一次，2=无线模式副本，3=怪物无限刷新的副本
        level : [1000,20000],//世界等级
        worldBoss : '无',//世界BOSS，即守关BOSS
        mythMonster : ['虚吾伊德'],//神话怪
    },
    '异世界·大地层' : {
        name : '异世界·大地层',
        map : '异世界·大地层',
        type : 1,//副本类型，1=每个怪物刷一次，2=无线模式副本，3=怪物无限刷新的副本
        level : [1000,20000],//世界等级
        worldBoss : '无',//世界BOSS，即守关BOSS
        mythMonster : ['异世界·固拉多'],//神话怪
    },
    '异世界·歌舞层' : {
        name : '异世界·歌舞层',
        map : '异世界·歌舞层',
        type : 1,//副本类型，1=每个怪物刷一次，2=无线模式副本，3=怪物无限刷新的副本
        level : [1000,20000],//世界等级
        worldBoss : '无',//世界BOSS，即守关BOSS
        mythMonster : ['异世界·美洛耶塔'],//神话怪
    },
    '异世界·时间层' : {
        name : '异世界·时间层',
        map : '异世界·时间层',
        type : 1,//副本类型，1=每个怪物刷一次，2=无线模式副本，3=怪物无限刷新的副本
        level : [1000,20000],//世界等级
        worldBoss : '无',//世界BOSS，即守关BOSS
        mythMonster : ['异世界·帝牙卢卡'],//神话怪
    },
    '异世界·百变层' : {
        name : '异世界·百变层',
        map : '异世界·百变层',
        type : 1,//副本类型，1=每个怪物刷一次，2=无线模式副本，3=怪物无限刷新的副本
        level : [1000,20000],//世界等级
        worldBoss : '无',//世界BOSS，即守关BOSS
        mythMonster : ['异世界·究极·百变怪'],//神话怪
    },
    '异世界·入梦层' : {
        name : '异世界·入梦层',
        map : '异世界·入梦层',
        type : 1,//副本类型，1=每个怪物刷一次，2=无线模式副本，3=怪物无限刷新的副本
        level : [1000,20000],//世界等级
        worldBoss : '无',//世界BOSS，即守关BOSS
        mythMonster : ['异世界·克雷色利亚'],//神话怪
    },
    '异世界·生命层' : {
        name : '异世界·生命层',
        map : '异世界·生命层',
        type : 1,//副本类型，1=每个怪物刷一次，2=无线模式副本，3=怪物无限刷新的副本
        level : [1000,20000],//世界等级
        worldBoss : '无',//世界BOSS，即守关BOSS
        mythMonster : ['异世界·究极·哲尔尼亚斯'],//神话怪
    },
    '生命神座' : {
        name : '生命神座',
        map : '生命神座',
        type : 1,//副本类型，1=每个怪物刷一次，2=无线模式副本，3=怪物无限刷新的副本
        level : [1000,200000],//世界等级
        worldBoss : '无',//世界BOSS，即守关BOSS
        mythMonster : ['生命女神'],//神话怪
    },
    '死亡神座' : {
        name : '死亡神座',
        map : '死亡神座',
        type : 1,//副本类型，1=每个怪物刷一次，2=无线模式副本，3=怪物无限刷新的副本
        level : [1000,200000],//世界等级
        worldBoss : '无',//世界BOSS，即守关BOSS
        mythMonster : ['异世界·死亡神座·伊裴尔塔尔'],//神话怪
    },
    '异世界·守层' : {
        name : '异世界·守层',
        map : '异世界·守层',
        type : 1,//副本类型，1=每个怪物刷一次，2=无线模式副本，3=怪物无限刷新的副本
        level : [1000,200000],//世界等级
        worldBoss : '无',//世界BOSS，即守关BOSS
        mythMonster : ['帝卫'],//神话怪
    },
    '后院' : {
        name : '后院',
        map : '花园',
        type : 2,
        level : [1,1000],
        worldBoss : '无',
        mythMonster : [],
    },
    '精英' : {
        name : '精英',
        map : '巢穴',
        type : 3,
        level : [1,1000],
        worldBoss : '无',
        mythMonster : [],
    },
    '传说' : {
        name : '传说',
        map : '领地',
        type : 3,
        level : [1,1000],
        worldBoss : '无',
        mythMonster : [],
    },
    '宝石' : {
        name : '宝石',
        map : '晶脉',
        type : 1,
        level : [1,1000],
        worldBoss : '无',
        mythMonster : [],
    },
    '粘液' : {
        name : '粘液',
        map : '果冻',
        type : 3,
        level : [1,1000],
        worldBoss : '无',
        mythMonster : [],
    },
    '自制' : {
        name : '自制',
        map : '舞台',
        type : 2,
        level : [1,1000],
        worldBoss : '无',
        mythMonster : [],
    },
};

//前往副本
function toDungeon(name){
    $('.map-btn-box').hide()
    data.dungeonKilled = [];
    data.inDungeon = true;
    data.worlds[data.worldIndex] = data.world;
    const map = [[dungeons[name].map]];
    if(!data.dungeonLog && dungeons[name].type == 2){
        says([`该副本为无限副本，死亡时不会真的死亡，会直接离开副本，打怪不掉落物品，离开副本时一并结算。具体说明见图鉴-说明-副本`])
    }
    data.dungeonLog = true;
    //转移世界
    data.world = {
        ...dungeons[name],
        map : map,//世界地图
        showMap : {},//key为显坐标，value为1则代表已经显示出来，否则就是空白显示
        mapElements : {},//地图元素集合
        home : {
            location : []//家的坐标[1,2]
        },
        nextPoint : null,
        prePoint : null,
        pass : false,//用于记录是否通关，即是否已经战胜守关BOSS
        mythMonster : []
    };
    saveWorlds();

    //切换地图
    data.map = data.world.map;
    data.location = [0,0];

    //将当前坐标和四周坐标设置为已探索
    setShowMap();
    //渲染可前往的地图
    renderCanToMap();
    //渲染地图
    renderMap();
    msg(`进入[${data.world.name}]`);
    //时间流逝
    timeLapses(5);
}

//获取无限模式副本的奖励
function getType2DungeonItems(){
    data.hp = data.maxHp;

    if (data.dungeonLevel == null) {
        data.dungeonLevel = 1;
    }
    if(data.dungeonLevel > 1){

        //记录最高击杀级别
        if(!data.killedLevels){
            data.killedLevels = {};
        }
        if(data.killedLevels[data.dungeonKilled[0]]){
            if(data.killedLevels[data.dungeonKilled[0]] < data.dungeonLevel - 1){
                data.killedLevels[data.dungeonKilled[0]] = data.dungeonLevel - 1;
            }
        }else{
            data.killedLevels[data.dungeonKilled[0]] = data.dungeonLevel - 1;
        }

        //获取奖励次数
        const num = data.dungeonLevel - 2;
        const cfg = monsterCfgs[data.dungeonKilled[0]];
        const items = [...cfg.items.map(e => ({name : e.name,minNum : e.minNum,maxNum : e.maxNum})),...getCommItems(cfg.type || '普通', cfg.level + (num * 5), false, cfg.tags)];

        //获取正常掉落物列表，不包括额外掉落
        const names = cfg.items.map(e => e.name);
        //正常掉落物才会增加掉落数量
        items.forEach(e => {
            if(names.indexOf(e.name) !== -1){
                e.maxNum += num * 2;
            }
        })

        //获取战利品
        const getItems = [];
        items.forEach(e => {
            const num = randomNum(e.minNum,e.maxNum);
            if(num > 0){
                addItem(e.name,num);
                getItems.push(`${e.name}*${num}`);
            }
        });
        if(getItems.length > 0){
            msg(`你在${data.world.name}中获得了：${ getItems.join()}`);
        }else{
            msg(`你在${data.world.name}中什么也没有获得`);
        }
    }
}

//离开副本
$('.body').on('click','.leave-dungeon',function(){
    //无限副本获取奖励
    if(dungeons[data.world.name] && dungeons[data.world.name].type === 2) {
        getType2DungeonItems();
    }

    data.dungeonKilled = [];
    data.dungeonLevel = 1;
    toWorld(data.worldIndex,false);
    data.location = data.worlds[data.worldIndex].home.location;
    data.inDungeon = false;
    //渲染地图元素
    renderMapElements();
    //渲染可前往的地图
    renderCanToMap();
    //渲染地图
    renderMap();
    //时间流逝
    timeLapses(5);
})
