//变异概率(百分之)
const variationRate = 90;
//可变异等级差
const variationLevel = 5;

//变异词条,level代表词条等级，怪物只能获得不高于自己等级的词条。num代表基础掉落的变异核心数量，也代表了附魔等级，num=2的词缀至少需要20个变异核心，以此类推
const variations = {
    '元气的' : {atk : 1000, def : 1000, hp : 10000, level : 1, num : 1},
    '勇敢的' : {atk : 100, def : 100, hp : 1000, level : 1, num : 1},
    '顽强的' : {atk : 100, def : 100, hp : 1000, level : 1, num : 1},

    '倔强的' : {atk : 150, def : 150, hp : 1500, level : 5, num : 2},
    '不屈的' : {atk : 150, def : 150, hp : 1500, level : 5, num : 2},
    '愤怒的' : {atk : 1500, def : 1500, hp : 15000, level : 5, num : 2},

    '神气' : {atk : 2000, def : 2000, hp : 20000, level : 10, num : 3},
    '强攻' : {atk : 200, def : 200, hp : 2000, level : 10, num : 3},
    '防御' : {atk : 200, def : 200, hp : 2000, level : 10, num : 3},
    '气血' : {atk : 200, def : 200, hp : 2000, level : 10, num : 3},

    '战士' : {atk : 250, def : 250, hp : 2500, level : 15, num : 4},
    '骑士' : {atk : 250, def : 250, hp : 2500, level : 15, num : 4},
    '守卫' : {atk : 2500, def :2500, hp : 25000, level : 15, num : 4},

    '强大的' : {atk : 5000, def : 5000, hp : 50000, level : 20, num : 5},
    '有力的' : {atk : 500, def : 500, hp : 5000, level : 20, num : 5},
    '耐打的' : {atk : 500, def : 500, hp : 5000, level : 20, num : 5},
    '血厚的' : {atk : 500, def : 500, hp : 0500, level : 20, num : 5},

    '凶狠的' : {atk : 800, def : 800, hp : 8000, level : 25, num : 6},
    '壮硕的' : {atk : 800, def : 800, hp : 8000, level : 25, num : 6},
    '防守的' : {atk : 8000, def : 8000, hp : 80000, level : 25, num : 6},

    '战斗' : {atk : 100, def : 1000, hp : 40000, level : 30, num : 7},
    '巨力' : {atk : 1000, def : 1000, hp : 40000, level : 30, num : 7},
    '格挡' : {atk : 1000, def : 1000, hp : 40000, level : 30, num : 7},
    '山海' : {atk : 10000, def : 10000, hp : 400000, level : 30, num : 7},

    '战斗的' : {atk : 10000, def : 10000, hp : 400000, level : 35, num : 8},
    '持盾的' : {atk : 1000, def : 1000, hp : 40000, level : 35, num : 8},
    '丰满的' : {atk : 1000, def : 1000, hp : 40000, level : 35, num : 8},

    '角斗士' : {atk : 2500, def : 2500, hp : 80000, level : 40, num : 9},
    '利爪' : {atk : 2500, def : 2500, hp : 80000, level : 40, num : 9},
    '厚皮' : {atk : 2500, def : 2500, hp : 80000, level : 40, num : 9},
    '结实的' : {atk : 25000, def : 25000, hp : 800000, level : 40, num : 9},

    '半兽人' : {atk : 2500, def : 2500, hp : 800000, level : 45, num : 10},
    '始祖龟' : {atk : 30000, def : 30000, hp : 800000, level : 45, num : 10},
    '大矮人' : {atk : 2500, def : 1000, hp : 80000, level : 45, num : 10},

    '巨人' : {atk : 5000, def : 5000, hp : 100000, level : 50, num : 11},
    '巨兽' : {atk : 5000, def : 5000, hp : 100000, level : 50, num : 11},
    '石象' : {atk : 5000, def : 5000, hp : 100000, level : 50, num : 11},
    '铁塔' : {atk : 5000, def : 5000, hp : 1000000, level : 50, num : 11},

    '擎天' : {atk : 25000, def : 25000, hp : 100000, level : 55, num : 12},
    '追日' : {atk : 5000, def : 5000, hp : 100000, level : 55, num : 12},
    '开山' : {atk : 5000, def : 500, hp : 100000, level : 55, num : 12},

    '冥王' : {atk : 50000, def : 50000, hp : 1000000, level : 60, num : 13},
    '魔笛' : {atk : 5000, def : 5000, hp : 100000, level : 60, num : 13},
    '神剑' : {atk : 5000, def : 5000, hp : 100000, level : 60, num : 13},
    '神铠' : {atk : 5000, def : 5000, hp : 100000, level : 60, num : 13},

    '终结者' : {atk : 50000, def : 50000, hp : 1000000, level : 65, num : 14},
    '开天者' : {atk : 5000, def : 5000, hp : 100000, level : 65, num : 14},
    '断海者' : {atk : 10000, def : 10000, hp : 100000, level : 65, num : 14},

    '不灭之握' : {atk : 100000, def : 100000, hp : 1000000, level : 70, num : 15},
    '山岚之风' : {atk : 5000, def : 5000, hp : 100000, level : 70, num : 15},
    '不熄之火' : {atk : 5000, def : 5000, hp : 100000, level : 70, num : 15},
    '不屈意志' : {atk : 5000, def : 5000, hp : 100000, level : 70, num : 15},

    '断剑' : {atk : 50000, def : 5000, hp : 100000, level : 75, num : 16},
    '破盾' : {atk : 5000, def : 50000, hp : 100000, level : 75, num : 16},
    '碎心' : {atk : 50000, def : 50000, hp : 1000000, level : 75, num : 16},

    '仰望者' : {atk : 10000, def : 10000, hp : 1000000, level : 80, num : 17},
    '信仰者' : {atk : 10000, def : 10000, hp : 1000000, level : 80, num : 17},
    '追逐者' : {atk : 10000, def : 10000, hp : 1000000, level : 80, num : 17},
    '挑战者' : {atk : 100000, def : 100000, hp : 10000000, level : 80, num : 17},

    '心剑' : {atk : 100000, def : 100000, hp : 10000000, level : 85, num : 18},
    '念盾' : {atk : 10000, def : 10000, hp : 1000000, level : 85, num : 18},
    '魂霸' : {atk : 10000, def : 10000, hp : 1000000, level : 85, num : 18},

    '身心一体' : {atk : 100000, def : 100000, hp : 1000000, level : 90, num : 19},
    '意由心生' : {atk : 100000, def : 100000, hp : 1000000, level : 90, num : 19},
    '灵体合一' : {atk : 100000, def : 100000, hp : 1000000, level : 90, num : 19},
    '生生不息' : {atk : 1000000, def : 1000000, hp : 10000000, level : 90, num : 19},

    '山河碎' : {atk : 1000000, def : 1000000, hp : 10000000, level : 95, num : 20},
    '万物生' : {atk : 1000000, def : 1000000, hp : 10000000, level : 95, num : 20},
    '天地变' : {atk : 1000000, def : 1000000, hp : 10000000, level : 95, num : 20},

    '饿饿萝莉' : {atk : 1000000, def : 1000000, hp : 1000000, level : 200, num : 21},
    '饭饭萝莉' : {atk : 10000000, def : 10000000, hp : 10000000, level : 200, num : 21},
    '小幼迦萝莉' : {atk : 1000000, def : 1000000, hp : 1000000, level : 300, num : 21},
    '萌萌哒幼迦萝莉' : {atk : 10000000, def : 10000000, hp : 10000000, level : 300, num : 21},
    '小幼纸萝莉' : {atk : 1000000, def : 1000000, hp : 1000000, level : 400, num : 21},
    '幼纸萝莉' : {atk : 10000000, def : 10000000, hp : 10000000, level : 400, num : 21},
    '小美萝莉' : {atk : 1000000, def : 1000000, hp : 1000000, level : 500, num : 21},
    '幼美萝莉' : {atk : 10000000, def : 10000000, hp : 10000000, level : 500, num : 21},
    '百变萝莉' : {atk : 1000000, def : 1000000, hp : 1000000, level : 600, num : 21},
    '百变萌萝' : {atk : 10000000, def : 10000000, hp : 10000000, level : 600, num : 21},
    '梦境萝莉' : {atk : 1000000, def : 1000000, hp : 1000000, level : 700, num : 21},
    '月女萝莉' : {atk : 10000000, def : 10000000, hp : 10000000, level : 700, num : 21},
    '血色萝莉' : {atk : 1000000, def : 1000000, hp : 1000000, level : 800, num : 21},
    '幼涩萝莉' : {atk : 10000000, def : 10000000, hp : 10000000, level : 800, num : 21},
    '智慧萝莉' : {atk : 1000000, def : 1000000, hp : 1000000, level : 900, num : 21},
    '知识萝莉' : {atk : 10000000, def : 10000000, hp : 10000000, level : 900, num : 21},
    '小幼龙萝莉' : {atk : 1000000, def : 1000000, hp : 1000000, level : 1000, num : 21},
    '幼龙萝莉' : {atk : 10000000, def : 10000000, hp : 10000000, level : 1000, num : 21},
    '小幼安希萝莉' : {atk : 1000000, def : 1000000, hp : 1000000, level : 2000, num : 21},
    '萌萌哒幼安希萝莉' : {atk : 10000000, def : 10000000, hp : 10000000, level : 2000, num : 21},
    '幼女萝莉' : {atk : 1000000, def : 1000000, hp : 1000000, level : 3000, num : 21},
    '梦缘萝莉' : {atk : 10000000, def : 10000000, hp : 10000000, level : 3000, num : 21},
    '虚幻萝莉' : {atk : 10000000, def : 10000000, hp : 10000000, level : 4000, num : 21},
    '虚无萝莉' : {atk : 100000000, def : 100000000, hp : 100000000, level : 4000, num : 21},
    '固执萝莉' : {atk : 10000000, def : 10000000, hp : 10000000, level : 5000, num : 21},
    '实体萝莉' : {atk : 100000000, def : 100000000, hp : 100000000, level : 5000, num : 21},
    '歌姬萝莉' : {atk : 10000000, def : 10000000, hp : 10000000, level : 6000, num : 21},
    '双生萝莉' : {atk : 100000000, def : 100000000, hp : 100000000, level : 6000, num : 21},
    '时间萝莉' : {atk : 10000000, def : 10000000, hp : 10000000, level : 7000, num : 21},
    '时空萝莉' : {atk : 100000000, def : 100000000, hp : 100000000, level : 7000, num : 21},
    '究极百变萝莉' : {atk : 1000000, def : 1000000, hp : 1000000, level : 8000, num : 21},
    '究极百变萌萝' : {atk : 10000000, def : 10000000, hp : 10000000, level : 8000, num : 21},
    '美梦萝莉' : {atk : 1000000, def : 1000000, hp : 1000000, level : 9000, num : 21},
    '梦缘萌萝' : {atk : 10000000, def : 10000000, hp : 10000000, level : 9000, num : 21},
    '生命主宰' : {atk : 10000000, def : 10000000, hp : 10000000, level : 10000, num : 21},
    '生命萌萝' : {atk : 100000000, def : 100000000, hp : 100000000, level : 10000, num : 21},
    '大地主宰' : {atk : 10000000, def : 10000000, hp : 10000000, level : 20000, num : 21},
    '大地之女' : {atk : 100000000, def : 100000000, hp : 100000000, level : 20000, num : 21},
    '生命神萝' : {atk : 10000000, def : 10000000, hp : 10000000, level : 30000, num : 21},
    '生命神女' : {atk : 100000000, def : 100000000, hp : 100000000, level : 30000, num : 21},
};