const map5LingguMonster = {
    '幽光精灵' : {
        tags : ['不死族', '幽灵'],
        atkTime : '全天',
        atkProb : 5,
        level : 41,
        hp : 1800,
        atk : 100,
        def : 0,
        exp : 2000,
        atkSpd : 3,
        type : null,
        items : [{name : '精灵气息',minNum : 1, maxNum : 1},{name : '幽光碎片',minNum : 1, maxNum : 2},{name : '不死印记',minNum : -98, maxNum : 1},{name : '不灭灵魂',minNum : -98, maxNum : 1}],
    },
    '黑暗之影' : {
        tags : ['不死族', '幽灵'],
        atkTime : '全天',
        atkProb : 5,
        level : 42,
        hp : 1900,
        atk : 120,
        def : 0,
        exp : 2100,
        atkSpd : 3,
        type : null,
        items : [{name : '黑暗灵团',minNum : 1, maxNum : 2},{name : '暗影精油',minNum : 0, maxNum : 2},{name : '不死印记',minNum : -98, maxNum : 1},{name : '不灭灵魂',minNum : -98, maxNum : 1}],
    },
    '草木精魂' : {
        tags : ['不死族', '幽灵'],
        atkTime : '全天',
        atkProb : 5,
        level : 43,
        hp : 2000,
        atk : 130,
        def : 0,
        exp : 2200,
        atkSpd : 3,
        type : null,
        items : [{name : '草木精华',minNum : 1, maxNum : 1},{name : '自然魂魄',minNum : 1, maxNum : 1},{name : '不死印记',minNum : -98, maxNum : 1},{name : '不灭灵魂',minNum : -98, maxNum : 1}],
    },
    '游荡残魂' : {
        tags : ['不死族', '幽灵'],
        atkTime : '全天',
        atkProb : 5,
        level : 44,
        hp : 2300,
        atk : 150,
        def : 0,
        exp : 2300,
        atkSpd : 3,
        type : null,
        items : [{name : '残破的记忆',minNum : 1, maxNum : 3},{name : '迷茫的灵魂',minNum : 1, maxNum : 1},{name : '不死印记',minNum : -98, maxNum : 1},{name : '不灭灵魂',minNum : -98, maxNum : 1}],
    },
    '寄灵死尸' : {
        tags : ['不死族', '人型生物'],
        atkTime : '全天',
        atkProb : 5,
        level : 45,
        hp : 3500,
        atk : 150,
        def : 50,
        exp : 2400,
        atkSpd : 3,
        type : null,
        items : [{name : '风干骨肉',minNum : 1, maxNum : 3},{name : '萎缩脑核',minNum : 1, maxNum : 1},{name : '不死印记',minNum : -98, maxNum : 1},{name : '不灭灵魂',minNum : -98, maxNum : 1}],
    },
    '噬魂兽' : {
        tags : ['不死族', '魔兽'],
        atkTime : '全天',
        atkProb : 5,
        level : 46,
        hp : 4000,
        atk : 160,
        def : 100,
        exp : 2500,
        atkSpd : 3,
        type : null,
        items : [{name : '噬灵獠牙',minNum : 1, maxNum : 2},{name : '破魂利爪',minNum : 1, maxNum : 2},{name : '不死印记',minNum : -98, maxNum : 1},{name : '不灭灵魂',minNum : -98, maxNum : 1}],
    },
    '自然之灵' : {
        tags : ['不死族', '幽灵'],
        atkTime : '全天',
        atkProb : 5,
        level : 47,
        hp : 3000,
        atk : 150,
        def : 0,
        exp : 2600,
        atkSpd : 3,
        type : null,
        items : [{name : '自然之心',minNum : 1, maxNum : 1},{name : '静谧的灵魂',minNum : 1, maxNum : 1},{name : '不死印记',minNum : -98, maxNum : 1},{name : '不灭灵魂',minNum : -98, maxNum : 1}],
    },
    '幽灵猎手' : {
        tags : ['不死族', '幽灵', '人型生物'],
        atkTime : '全天',
        atkProb : 5,
        level : 48,
        hp : 3000,
        atk : 200,
        def : 0,
        exp : 2700,
        atkSpd : 3,
        type : null,
        items : [{name : '幽灵猎刀',minNum : 1, maxNum : 1},{name : '杀戮意志',minNum : 1, maxNum : 1},{name : '不死印记',minNum : -98, maxNum : 1},{name : '不灭灵魂',minNum : -98, maxNum : 1}],
    },
    '幽灵魔像' : {
        tags : ['不死族', '幽灵', '傀儡'],
        atkTime : '全天',
        atkProb : 5,
        level : 49,
        hp : 4000,
        atk : 180,
        def : 0,
        exp : 2800,
        atkSpd : 3,
        type : null,
        items : [{name : '幽灵石',minNum : 1, maxNum : 3},{name : '幽灵核心',minNum : 1, maxNum : 1},{name : '不死印记',minNum : -98, maxNum : 1},{name : '不灭灵魂',minNum : -98, maxNum : 1}],
    },
    '灵魂缝合怪' : {
        tags : ['不死族', '幽灵'],
        atkTime : '全天',
        atkProb : 5,
        level : 50,
        hp : 4000,
        atk : 200,
        def : 0,
        exp : 2900,
        atkSpd : 5,
        type : null,
        items : [{name : '灵魂粘合剂',minNum : 1, maxNum : 2},{name : '缝合的意识',minNum : 1, maxNum : 1},{name : '不死印记',minNum : -98, maxNum : 1},{name : '不灭灵魂',minNum : -98, maxNum : 1}],
    },
    '半灵人' : {
        tags : ['不死族', '幽灵', '人型生物'],
        atkTime : '全天',
        atkProb : 0,
        level : 50,
        hp : 12000,
        atk : 200,
        def : 0,
        exp : 9000,
        atkSpd : 3,
        type : '精英',
        items : [{name : '不死印记',minNum : 0, maxNum : 1},{name : '不灭灵魂',minNum : 0, maxNum : 1},{name : '死灵之书',minNum : 1, maxNum : 1},{name : '灵魂护符',minNum : 1, maxNum : 1}],
    },
    '复活的血肉' : {
        tags : ['不死族'],
        atkTime : '全天',
        atkProb : 0,
        level : 50,
        hp : 30000,
        atk : 220,
        def : 100,
        exp : 9000,
        atkSpd : 3,
        type : '精英',
        items : [{name : '不死印记',minNum : 0, maxNum : 1},{name : '不灭灵魂',minNum : 0, maxNum : 1},{name : '特制尸油',minNum : 1, maxNum : 3}],
    },
    '驱灵人' : {
        tags : ['人型生物'],
        atkTime : '日',
        atkProb : 0,
        human : true,
        level : 50,
        hp : 30000,
        atk : 350,
        def : 50,
        exp : 12000,
        atkSpd : 3,
        type : '传说',
        items : [{name : '驱灵印记',minNum : 1, maxNum : 1},{name : '咒术心脏',minNum : 1, maxNum : 1}],
    },
    '灾祸之灵' : {
        tags : ['不死族', '幽灵'],
        atkTime : '全天',
        atkProb : 0,
        level : 50,
        hp : 30000,
        atk : 380,
        def : 0,
        exp : 15000,
        atkSpd : 3,
        type : '神话',
        items : [{name : '灾祸气息',minNum : 1, maxNum : 3},{name : '灾祸预兆',minNum : 1, maxNum : 1},{name : '不死印记',minNum : 1, maxNum : 1},{name : '不灭灵魂',minNum : 1, maxNum : 1}],
    },
    '黑暗低语' : {
        tags : ['污染'],
        atkTime : '全天',
        atkProb : 0,
        level : 50,
        hp : 35000,
        atk : 400,
        def : 0,
        exp : 15000,
        atkSpd : 3,
        type : '神话',
        items : [{name : '位面坐标：深渊',minNum : -3, maxNum : 1},{name : '影魔传说',minNum : -50, maxNum : 1},{name : '变异核心',minNum : 1000, maxNum : 1000}],
    },
    '无形意志' : {
        tags : ['不死族', '幽灵'],
        atkTime : '全天',
        atkProb : 0,
        level : 50,
        hp : 100000,
        atk : 200,
        def : 0,
        exp : 90000,
        atkSpd : 3,
        noOneKill : true,
        type : '神话',
        items : [{name : '50级武器打孔石',minNum : 1, maxNum : 3},{name : '50级护甲打孔石',minNum : 1, maxNum : 3},{name : '世界之力：16点',minNum : 1, maxNum : 1}],
    },
};

//地图信息
const map5Linggu = {
    index : 4,
    name : '灵谷',
    level : [41,50],
    worldBoss : '驱灵人',
    mythMonster : ['灾祸之灵','黑暗低语'],
    finalBoss : '无形意志',

    //配置
    confs : {
        //地形列表
        terrainArray : [
            '灵丛','寒池','光壁','星柱','祭坛','黑雾','莹巢','鬼林',//新地形
        ],
        //地形可以和哪些其他地形相邻
        terrainJoinTerrain : {
            '灵丛' : ['灵丛','寒池','光壁','星柱','祭坛','黑雾','莹巢','鬼林'],
            '寒池' : ['灵丛','寒池','光壁','星柱','祭坛','黑雾','莹巢','鬼林'],
            '光壁' : ['灵丛','寒池','光壁','星柱','祭坛','黑雾','莹巢','鬼林'],
            '星柱' : ['灵丛','寒池','光壁','星柱','祭坛','黑雾','莹巢','鬼林'],
            '祭坛' : ['灵丛','寒池','光壁','星柱','祭坛','黑雾','莹巢','鬼林'],
            '黑雾' : ['灵丛','寒池','光壁','星柱','祭坛','黑雾','莹巢','鬼林'],
            '莹巢' : ['灵丛','寒池','光壁','星柱','祭坛','黑雾','莹巢','鬼林'],
            '鬼林' : ['灵丛','寒池','光壁','星柱','祭坛','黑雾','莹巢','鬼林'],
        },
        //地形可以和哪些其他地形相邻，这里面的配置会追加到当前已有的地形中
        terrainJoinTerrainAppend : {},
        //每个地形对应的颜色
        terrainColor : {
            '灵丛' : '#89ccdb',
            '寒池' : '#2196f3',
            '光壁' : '#29ffe9',
            '星柱' : '#cb6904',
            '祭坛' : '#6b6c6b',
            '黑雾' : '#795548',
            '莹巢' : '#009688',
            '鬼林' : '#9c27b0',
        },
        //怪物列表
        monsters : map5LingguMonster,
        //地形下的怪物和资源，如果是已有的地形，则会在原本的基础上追加，否则会新建，要注意得有上个地图的守关BOSS
        terrainElements : {
            '灵丛' : {
                monster : {
                    幽光精灵 : 80,
                    草木精魂 : 90,
                    自然之灵 : 80,
                    半灵人 : 5,
                },
                elements : {
                    ...terrainElement('幽灵花丛', [1, 3], 5),
                }
            },
            '寒池' : {
                monster : {
                    幽光精灵 : 60,
                    游荡残魂 : 80,
                    寄灵死尸 : 90,
                    灵魂缝合怪 : 30,
                },
                elements : {
                    ...terrainElement('水源', [1, 3], 5),
                    ...terrainElement('幽灵矿脉', [0, 1], 1),
                }
            },
            '光壁' : {
                monster : {
                    黑暗之影 : 80,
                    幽灵魔像 : 90,
                },
                elements : {
                    ...terrainElement('幽灵矿脉', [1, 3], 3),
                }
            },
            '星柱' : {
                monster : {
                    黑暗之影 : 50,
                    游荡残魂 : 70,
                    幽灵魔像 : 80,
                },
                elements : {
                    ...terrainElement('幽灵矿脉', [1, 2], 2),
                }
            },
            '祭坛' : {
                monster : {
                    寄灵死尸 : 80,
                    灵魂缝合怪 : 90,
                    半灵人 : 5,
                },
                elements : {
                }
            },
            '黑雾' : {
                monster : {
                    幽光精灵 : 60,
                    黑暗之影 : 90,
                    游荡残魂 : 50,
                    噬魂兽 : 80,
                    幽灵猎手 : 70,
                    半灵人 : 5,
                },
                elements : {
                    ...terrainElement('幽灵花丛', [0, 2], 3),
                }
            },
            '莹巢' : {
                monster : {
                    草木精魂 : 90,
                    噬魂兽 : 70,
                    自然之灵 : 90,
                },
                elements : {
                    ...terrainElement('幽灵花丛', [0, 2], 3),
                }
            },
            '鬼林' : {
                monster : {
                    草木精魂 : 90,
                    噬魂兽 : 80,
                    幽灵猎手 : 90,
                    半灵人 : 5,
                },
                elements : {
                    ...terrainElement('活树', [1, 3], 5),
                }
            },
        },
        //采集元素
        elements : {
            //地图上生成的可采集资源
            '幽灵矿脉' : new Element({canGather :true, mopUp : true, time : 10, num : 3, needItem : ['铁镐','光荣镐'], getItem : [{name : '幽灵结晶',minNum : 1, maxNum : 2}]}),
            '幽灵花丛' : new Element({canGather :true, mopUp : true, time : 10, num : 3, day : 3,getItem : [{name : '幽灵花',minNum : 1, maxNum : 2}]}),
            '活树' : new Element({canGather :true, mopUp : true, time : 20, num : 10, day : 5, needItem : ['铁斧','光荣斧'], getItem : [{name : '活木头',minNum : 0, maxNum : 1}]}),

            //本地图的元素，例如：药剂，药膏，背包，盾牌，装备，坐骑，投掷品，弓胚
            '幽灵结晶' : new Element({voidDust : 10, gold : 50, elemental : {土 : 5}}),
            '幽灵花' : new Element({canUse : true, hp : 3, voidDust : 6, gold : 30, elemental : {木 : 1}}),
            '活木头' : new Element({voidDust : 20, gold : 100, elemental : {土 : 4, 木 : 3}}),
        },
        //怪物掉落物品
        monsterItems : {
            '精灵气息' : new Element({fromMonster : true, voidDust : 25, gold : 75, elemental : {木 : 4, 土 : 6}}),
            '幽光碎片' : new Element({fromMonster : true, voidDust : 45, gold : 225, elemental : {土 : 8}}),
            '黑暗灵团' : new Element({fromMonster : true, voidDust : 45, gold : 225, elemental : {金 : 4, 土 : 6}}),
            '暗影精油' : new Element({fromMonster : true, voidDust : 45, gold : 225, elemental : {金 : 7, 土 : 4}}),
            '草木精华' : new Element({fromMonster : true, voidDust : 45, gold : 225, elemental : {金 : 7, 木 : 4}}),
            '自然魂魄' : new Element({fromMonster : true, voidDust : 50, gold : 250, elemental : {木 : 3, 土 : 4}}),
            '残破的记忆' : new Element({fromMonster : true, voidDust : 50, gold : 250, elemental : {金 : 4, 土 : 5}}),
            '迷茫的灵魂' : new Element({fromMonster : true, voidDust : 60, gold : 300, elemental : {木 : 7, 土 : 2}}),
            '风干骨肉' : new Element({fromMonster : true, voidDust : 60, gold : 300, elemental : {木 : 6, 土 : 2}}),
            '萎缩脑核' : new Element({fromMonster : true, voidDust : 65, gold : 325, elemental : {金 : 5, 土 : 3}}),
            '噬灵獠牙' : new Element({fromMonster : true, voidDust : 65, gold : 325, elemental : {金 : 6, 土 : 4}}),
            '破魂利爪' : new Element({fromMonster : true, voidDust : 65, gold : 325, elemental : {金 : 3, 土 : 5}}),
            '自然之心' : new Element({fromMonster : true, voidDust : 65, gold : 325, elemental : {木 : 3, 水 : 8}}),
            '静谧的灵魂' : new Element({fromMonster : true, voidDust : 70, gold : 350, elemental : {木 : 4, 土 : 5}}),
            '幽灵猎刀' : new Element({fromMonster : true, voidDust : 70, gold : 350, elemental : {木 : 7, 土 : 4}}),
            '杀戮意志' : new Element({fromMonster : true, voidDust : 70, gold : 350, elemental : {土 : 7, 金 : 3}}),
            '幽灵石' : new Element({fromMonster : true, voidDust : 70, gold : 350, elemental : {木 : 2, 金 : 5}}),
            '幽灵核心' : new Element({fromMonster : true, voidDust : 80, gold : 400, elemental : {土 : 10}}),
            '灵魂粘合剂' : new Element({fromMonster : true, voidDust : 50, gold : 250, elemental : {土 : 5}}),
            '缝合的意识' : new Element({fromMonster : true, voidDust : 400, gold : 2000, elemental : {木 : 3, 金 : 2}}),
            '驱灵印记' : new Element({fromMonster : true, voidDust : 400, gold : 2000, elemental : {木 : 3, 金 : 2}}),
            '咒术心脏' : new Element({fromMonster : true, voidDust : 400, gold : 2000, elemental : {极 : 8}}),
            '灾祸气息' : new Element({fromMonster : true, voidDust : 700, gold : 3500, elemental : {木 : 10, 极 : 1}}),
            '灾祸预兆' : new Element({fromMonster : true, voidDust : 700, gold : 3500, elemental : {木 : 8, 土 : 5, 极 : 1}}),
        },
        //怪物技能
        monsterSkill : {
            幽光精灵 : ['灵魂攻击'],
            黑暗之影 : ['灵魂攻击'],
            草木精魂 : ['灵魂攻击'],
            游荡残魂 : ['灵魂攻击'],
            寄灵死尸 : [{
                name : '幽灵一击',
                extend : '横扫'
            }],
            噬魂兽 : ['灵魂攻击'],
            自然之灵 : ['灵魂攻击'],
            幽灵猎手 : ['灵魂攻击'],
            幽灵魔像 : [{
                name : '灵魂重拳',
                extend : '灵魂尖啸'
            }],
            灵魂缝合怪 : [{
                name : '灵魂分散',
                extend : '陨石术'
            }],
            半灵人 : ['灵魂攻击'],
            复活的血肉 : [{
                name : '再生',
                extend : '同化'
            }],
            驱灵人 : [{
                name : '灵魂撕裂',
                type : 'atk',
                text : '玩家有封印状态时，20%概率使用，造成1.5倍无视防御伤害',
                getStatus : function(){
                    return null;
                },
                check : function(){return  getStatuNum(data, '封印') && randomNum() <= 20},
                getNum : function(){return data.battleMonster.atk * 1.5 + (data.def > 0 ? data.def : 0)},
            },{
                name : '封灵',
                type : 'atk',
                text : '20%概率使用，造成0.8倍无视防御伤害，并封印玩家3回合',
                getStatus : function(){
                    return getStatus('封印', {num : 3});
                },
                check : function(){return randomNum() <= 20},
                getNum : function(){return data.battleMonster.atk * 0.8 + (data.def > 0 ? data.def : 0)},
            }],
            灾祸之灵 : [{
                name : '灾难降临',
                type : 'berserk',
                text : '生命值低于50%时必然使用，给玩家附加灾难状态，每回合降低生命上限的5%的血量，治疗效果减少50%。该状态不会自动消失。该技能只会使用一次',
                check : function(){return !data.battleMonster.znjl && data.battleMonster.hp < (data.battleMonster.maxHp * 0.5)},
                getNum : function(){return 0},
                use : function(){
                    addStatus(data, getStatus('灾难', {harm : parseInt(data.maxHp * 0.05)}))
                    addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了${this.name}，给你附加了灾难状态，每回合降低生命上限的5%的血量，治疗效果减少50%`);
                },
            }],
            黑暗低语 : [{
                name : '混沌低语',
                extend : '血肉转移'
            }],
            无形意志 : [{
                name : '意志操控',
                type : 'atk',
                normalAtk : true,
                text : '代替普通攻击使用，造成1倍无视防御伤害。并在当前属性的基础上提高10%攻击力和5%防御力，最少提高10点。',
                check : function(){return true},
                getStatus : function(){
                    worldBossAddAttr();
                    return null
                },
                getNum : function(){return data.battleMonster.atk + (data.def > 0 ? data.def : 0)},
            }],
        },
        //神殿配置
        deity : {
            水之女神 : {
                hates : [
                    {name : '黑暗之影', num : 10, godFavor : 50, belief : 50},
                    {name : '寄灵死尸', num : 10, godFavor : 60, belief : 60},
                    {name : '灵魂缝合怪', num : 10, godFavor : 80, belief : 80},
                ],
                likes : [
                    {name : '精灵气息', num : 10, godFavor : 50, belief : 50},
                    {name : '幽光碎片', num : 10, godFavor : 50, belief : 50},
                    {name : '草木精华', num : 10, godFavor : 50, belief : 50},
                    {name : '自然魂魄', num : 10, godFavor : 50, belief : 50},
                    {name : '自然之心', num : 10, godFavor : 70, belief : 70},
                    {name : '静谧的灵魂', num : 10, godFavor : 70, belief : 70},
                ],
            },
            狩猎之神 : {
                hates : [
                    {name : '噬魂兽', num : 10, godFavor : 60, belief : 60},
                    {name : '幽灵猎手', num : 10, godFavor : 70, belief : 70},
                ],
                likes : [
                    {name : '噬灵獠牙', num : 10, godFavor : 60, belief : 60},
                    {name : '破魂利爪', num : 10, godFavor : 60, belief : 60},
                    {name : '幽灵猎刀', num : 10, godFavor : 70, belief : 70},
                    {name : '杀戮意志', num : 10, godFavor : 70, belief : 70},
                ],
            }
        },
        //装备，这里的装备会自动生成图纸
        equip : {
            '灵魂之手' : new Element({onlyOne :true, isWeapon : true, atk : 150, def : -30, weight : 1, endurance : 300, voidDust : 800, level : 40, gold : 4000, fixNeedDust: 2}),
            '灵魂外套' : new Element({onlyOne :true, isArmor : true, atk : 30, def : 90, weight : 1, endurance : 300, voidDust : 800, level : 40, gold : 4000, fixNeedDust: 2}),
            '嗜灵之戟' : new Element({onlyOne :true, isWeapon : true, atk : 200, def : -40, weight : 1, endurance : 350, voidDust : 1000, level : 47, gold : 5000, fixNeedDust: 2}),
            '静谧之心' : new Element({onlyOne :true, isArmor : true, atk : 40, def : 120, weight : 1, endurance : 350, voidDust : 1000, level : 47, gold : 5000, fixNeedDust: 2}),
            '猎杀意志' : new Element({onlyOne :true, isWeapon : true, atk : 230, def : -50, weight : 1, endurance : 400, voidDust : 1100, level : 50, gold : 5500, fixNeedDust: 2}),
            '幽灵盔甲' : new Element({onlyOne :true, isArmor : true, atk : 50, def : 130, weight : 1, endurance : 400, voidDust : 1100, level : 50, gold : 5500, fixNeedDust: 2}),
        },
        //商店配置
        shop : {
            '资源' : ['纤维','木材','树枝','燧石','石头','幽灵结晶','幽灵花','活木头'],
            '食物' : ['水'],
            '素材' : ['铁锭','铜锭','金锭','精灵气息', '幽光碎片', '黑暗灵团', '暗影精油', '草木精华', '自然魂魄', '残破的记忆', '迷茫的灵魂', '风干骨肉', '萎缩脑核', '噬灵獠牙', '破魂利爪', '自然之心', '静谧的灵魂', '幽灵猎刀', '杀戮意志', '幽灵石', '幽灵核心', '灵魂粘合剂', '缝合的意识','虚空粉尘','变异核心'],
            '药品' : ['幽灵花','灵魂药膏'],
            '稀有物品' : ['不死印记','不灭灵魂','死灵之书','灵魂护符','神性结晶','驱灵印记', '咒术心脏', '灾祸气息', '灾祸预兆'],
        },
        //锻造配方，同时还需要考虑到：药膏，药剂，盾牌，投掷品，怪物物品DLC
        // 图2（灵魂追猎，遗忘之魂，次元移动），
        // 图3（穿甲箭，强化黑火药，魔兽皮包，弓胚：巨人杀手，紫水晶戒指，神性爆弹，）
        // 图4（魔蛟心脉精华，巨龙幼崽，骨刺炸药，珍贵皮包）
        forgeRecipes : {
            '灵魂之手' : createForgeRecipesCfg({'精灵气息' : 5,'暗影精油' : 10, '黑暗灵团' : 10, '自然魂魄' : 5}),
            '灵魂外套' : createForgeRecipesCfg({'幽光碎片' : 10,'草木精华' : 5, '暗影精油' : 10, '黑暗灵团' : 10}),
            '嗜灵之戟' : createForgeRecipesCfg({'迷茫的灵魂' : 5,'风干骨肉' : 15, '噬灵獠牙' : 10, '破魂利爪' : 10, '静谧的灵魂' : 5}),
            '静谧之心' : createForgeRecipesCfg({'残破的记忆' : 15,'萎缩脑核' : 5, '噬灵獠牙' : 10, '自然之心' : 5, '静谧的灵魂' : 5}),
            '猎杀意志' : createForgeRecipesCfg({'幽灵猎刀' : 5,'杀戮意志' : 5, '幽灵核心' : 5, '缝合的意识' : 5}),
            '幽灵盔甲' : createForgeRecipesCfg({'杀戮意志' : 5,'幽灵石' : 15, '幽灵核心' : 5, '灵魂粘合剂' : 10}),
        }
        //['精灵气息', '幽光碎片', '黑暗灵团', '暗影精油', '草木精华', '自然魂魄',
        // '残破的记忆', '迷茫的灵魂', '风干骨肉', '萎缩脑核', '噬灵獠牙', '破魂利爪', '自然之心', '静谧的灵魂',
        // '幽灵猎刀', '杀戮意志', '幽灵石', '幽灵核心', '灵魂粘合剂', '缝合的意识',
        // 、、， '驱灵印记', '咒术心脏', '灾祸气息', '灾祸预兆']
        //['幽光精灵', '黑暗之影', '草木精魂', '游荡残魂', '寄灵死尸', '噬魂兽', '自然之灵', '幽灵猎手', '幽灵魔像', '灵魂缝合怪', '半灵人', '复活的血肉', '驱灵人', '灾祸之灵', '黑暗低语', '无形意志']
    }
};
